<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Task_type_table extends Base_table {

	function __construct()
	{
        parent::__construct(array('tbl'=>'task_type', 'tbl_key'=>'task_type_id'));
	}

	public function save($data)
	{
		if($task_type_id = parent::save($data))
		{
			// update project task type billable value
			if (!empty($data[$this->tbl_key]))
			{
				$this->CI->db->where('task_type_id', $data['task_type_id']);
				$this->CI->db->update('project_task_types', array('is_billable' => $data['is_billable']));
			}
			return $task_type_id;
		}

		return false;
	}

	public function store_default_data ($data)
	{
		$this->CI->load->database();

		if (empty($data['entity_id'])) {
			return false;
		}

		$dynamic_data	= array(
			'entity_id'	=> $data['entity_id'],
		);

		$static_data = array(
			array(
				'name' 			=> 'Admin',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '1'
			),
			array(
				'name' 			=> 'Design',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '2'
			),
			array(
				'name' 			=> 'Engineering / Development',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '3'
			),
			array(
				'name' 			=> 'Meeting',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '4'
			),
			array(
				'name' 			=> 'Project Management',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '5'
			),
			array(
				'name' 			=> 'Quality Assurance',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '6'
			),
			array(
				'name' 			=> 'Sales / Biz Dev',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '7'
			),
			array(
				'name' 			=> 'Site Strategy',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '8'
			),
			array(
				'name' 			=> 'System Administration',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '9'
			),
			array(
				'name' 			=> 'Travel',
				'hourly_rate'	=> '0',
				'is_common'		=> '1',
				'sort_order'	=> '10'
			)
		);

		$values	= array();

		foreach ($static_data as $val) {
			$values[]	= array_merge($val,$dynamic_data);
		}
		return $this->CI->db->insert_batch($this->tbl, $values); 
	}
}
/* end of Task_type_table.php */
