<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	$isModule	= !empty($module_type) ? true : false;
//	$isProject	= $isModule && $module_type=='P';

	switch ($template)
	{
		case 'edit':
			$fields	= array(
				'form_open'		=> array(
					'class'			=> 'form-horizontal',
					'onsubmit'		=> 'return false;',
				),
				'first_name'	=> array(
					'class'			=> 'col-lg-12 form-control form-group',
					'data-bind'		=> 'value:first_name',
					'placeholder'	=> lang('FIRST_NAME'),
					'maxlength'	=> '30',
				),
				'last_name'	=> array(
					'class'			=> 'col-lg-12 form-control form-group',
					'data-bind'		=> 'value:last_name',
					'placeholder'	=> lang('LAST_NAME'),
					'maxlength'	=> '30',
				),
				'email'	=> array(
					'class'			=> 'col-lg-12 form-control form-group',
					'data-bind'		=> 'value:email',
					'placeholder'	=> lang('EMAIL'),
					'type'			=> 'email',
				),
				'hourly_rate'	=> array(
					'class'			=> 'col-md-10 db-input-addon',
					'data-bind'		=> 'value:hourly_rate, numberOnly:true',
					'maxlength'		=> 6,
					'placeholder'	=> lang('HOURLY_RATE'),
				),
				'user_role'	=> array(
					'class'			=> 'col-lg-12 select form-control',
					'options'		=> $user_role,
					'value'			=> '0',
					'extra'			=> 'data-bind="value:user_role"',
				),
//				'department'	=> array(
//					'id'			=> 'department',
//					'name'			=> 'department',
//					'class'			=> 'col-lg-12 form-control',
//					'options'		=> $departments,
//					'value'			=> '0',
//					'placeholder'	=> lang('DEPARTMENT'),
//					'extra'			=> 'data-bind="value:department, chosen:true"',
//				),
				'department'	=> array(
					'class'			=> 'col-lg-12 form-control form-group',
					'data-bind'		=> 'value:department, autoComplete:{source:getDepartments(), select:setDepartment}',
					'placeholder'	=> lang('DEPARTMENT'),
				),
				'password'		=> array(
					'class'			=> 'form-control input-md',
					'name'			=> 'password',
					'id'			=> 'password',
					'placeholder'	=> 'Password',
					'minlength'		=> '6',
					'maxlength'		=> '12',
					'data-bind'		=> 'value:password, valueUpdate:\'afterkeydown\'',
				),
				'confirm_password'		=> array(
					'class'			=> 'form-control input-md',
					'name'			=> 'confirm_password',
					'id'			=> 'confirm_password',
					'placeholder'	=> 'Confirm Password',
					'minlength'		=> '6',
					'maxlength'		=> '12',
					'data-bind'		=> 'value:confirm_password, visible:password().length',
				),
			);
?>
<?php if ($isModule): ?>
	<div class="container np">
		<div class="newuser">
<?php else: ?>
	<div class="container np" data-bind="with:targetItem">
		<div class="newuser col-md-7">
<?php endif; ?>
			<div class="content" id="user-edit">
				<div class="errorMsg"></div>
				<div class="row">
					<div class="pull-left col-lg-3" style="margin-right:25px;">
						<span class="pull-left align-left">
						<div id="company_browse">
							<i class="delete pull-right icon-remove cp" id="removeImage" data-bind="click:removeImage"></i>
							<div class="img-thumbnail cp">
								<div data-bind="click:uploadDialog" style="height:120px;width:120px;overflow:hidden;">
									<img fnt-size="70px" data-bind="img:user_image_path, attr:{title:first_name}" rel="tooltip" id="target-prof-img"/>
									<img fnt-size="70px" data-bind="img:oldImage, attr:{title:first_name}" style="display:none;" />
								</div>
							</div>
							<input type="file" data-bind="value:profile_image" id="profile_image" name="profile_image" class="fileUpload" />
						</div>
						</span>
					</div>
					<div class="col-lg-8 pull-left">
						<div class="row">
							<span class="col-lg-6 np">
								<?php echo form_input($fields['first_name']); ?>
							</span>
							<span class="col-lg-6 npr">
								<?php echo form_input($fields['last_name']); ?>
							</span>
						</div>
						<div class="row">
							<div class="col-lg-12 np">
								<?php echo form_input($fields['email']); ?>
							</div>
						</div>
						
						<div class="row">
							<?php if (is_admin() || is_pmf()): ?>
								<div class="col-lg-5 col-xs-4 np">
									<div class="form-group input-group">
										<div class="input-group form-control npr col-md-12">
											<?php echo form_input($fields['hourly_rate']); ?>
											<span class="input-group-addon db-input-addon npb">$</span>
										</div>
										<span class="input-group-addon h3">/hr</span>
									</div>
								</div>
								<span class="col-lg-1"></span>
							<?php endif; ?>
							<div class="<?php echo (is_admin() || is_pmf())?'col-lg-6 col-xs-6 np':'col-lg-12 np';?>">
								<div class="form-group">
									<?php echo form_input($fields['department']); ?>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="form-group">
								<select class="select form-control" data-bind="value:time_zone_code, chosen:true"><?php
									foreach (timezones() as $key=>$val):
										echo '<option value="' . $key . '">' . lang($key) . '</option>';
									endforeach;
								?></select>
							</div>
						</div>
						<div class="row">
							<div class="input-group form-group">
								<span class="input-group-addon">
									<span class="icon-lock"></span>
								</span>
								<?php echo form_password($fields['password']); ?>
							</div>
						</div>
						<div class="row" data-bind="visible:password().length">
							<div class="input-group form-group">
								<span class="input-group-addon">
									<span class="icon-lock"></span>
								</span>
								<?php echo form_password($fields['confirm_password']); ?>
							</div>
						</div>
						<div class="sep">&nbsp;</div>
						<?php if (is_admin() || is_pmf()): ?>
							<div class="row">
								<?php foreach ($user_role as $key=>$val): ?><div class="radio"><label><input type="radio" data-bind="checked:user_role, enable:edit_role_permission" name="user_role" value="<?php echo $key; ?>"><?php echo $val; ?></label></div><?php endforeach; ?>								
							</div>
						<?php endif; ?>
						<div class="clearfix">&nbsp;</div>
						<?php /*if (!is_member()): ?>
						<div class="row">
							<label><?php echo lang('EMAIL_SUBSCRIPTION'); ?></label>
							<div class="checkbox"><label data-bind="css:{'cur_default':(user_role()=='M')}"><input type="checkbox" data-bind="enable:user_role()!='M', checked:is_weekly_mail" name="mail_type" value="<?php echo 'W'; ?>"><?php echo lang('WEEKLY_MAIL'); ?></label></div>
						</div>
						<div class="clearfix">&nbsp;</div>
						<?php endif; */ ?>
<?php if (!$isModule): ?>
						<div class="saveuser btn-group row col-md-offset-5" style="display:block">
							<button data-bind="click:save" class="btn btn-success btn-sm" id="save"><i class="icon icon-save icon-white"></i>&nbsp;&nbsp;<?php echo lang('SAVE'); ?></button>&nbsp;&nbsp;&nbsp;
							<button class="btn btn-primary btn-sm" data-bind="click:cancel" name="cancel">
								<span class="icon-remove-sign icon-white"></span>
							</button>
						</div>
						<div class="clearfix">&nbsp;</div>
<?php endif; ?>
					</div>
				</div>
			</div>
		</div>
		<div class="modal" id="crop_image" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
						<h4 class="modal-title"><?php echo lang('SET_AS_USER_PHOTO'); ?></h4>
					</div>
					<div class="modal-body form-horizontal dib">
						<img data-bind="img:user_image_path, attr:{title:first_name}" id="target" />
						<div id="preview-pane">
							<div class="preview-container">
								<img data-bind="img:user_image_path, attr:{title:first_name}" class="jcrop-preview" alt="Preview" />
							</div>
							<div class="clearfix">&nbsp;</div>
							<button class="btn btn-success" data-bind="click:cropApply"><?php echo lang('APPLY'); ?></button>
						</div>
					</div>
				</div>
			</div>
		</div>
<?php if (!$isModule): ?>
		<div id="projects-list" class="col-lg-5" data-bind="visible:user_id()>0">
			<div class="row">
				<div class="control-group">
					<div class="control-header row">
						<div class="col-md-4" data-bind="visible:is_active()==1">
							<a href="javascript:;" data-bind="click:archiveItem(0)" class="text-primary"><u><?php echo lang('ARCHIVE_USER'); ?></u></a>
						</div>
						<div class="col-md-4" data-bind="visible:is_active()==0">
							<a href="javascript:;" data-bind="click:archiveItem(1)" class="text-primary"><u><?php echo lang('UNARCHIVE_USER'); ?></u></a>
						</div>
						<div class="col-md-4">
							<a href="javascript:;" class="text-primary" data-bind="click:show_activity">
								<u><?php echo lang('USER_ACTIONS'); ?></u>
							</a>
						</div>
						<div class="col-md-3" data-bind="hidden:_project.total_hours()>0 || is_active()==1">
							<a href="javascript:;" data-bind="click:deleteItem" class="text-primary">
								<u><?php echo lang('DELETE_THIS_USER'); ?></u>
							</a>
						</div>
						<div class="col-md-4">
							<a href="javascript:;" data-bind="click:reset" class="text-primary">
								<u><?php echo lang('RESET_PASSWORD'); ?></u>
							</a>
						</div>
					</div>
					<div class="clearfix">&nbsp;</div>
				</div>
				<div class="control-group">
		    		<div class="panel panel-primary nmb">
						<div class="panel-heading clearfix">
							<div class="pull-left total-bg">
								<h2 data-bind="text:_project.total_projects" class="col-md-1"></h2>
							</div>
							<div class="col-md-5 col-xs-5">								
								<h4 class="modal-title"><?php echo lang('PROJECTS'); ?></h4>
								<div>
									<div class="pull-left">
										<h3 data-bind="text:_project.active_projects" class="nm"></h3>
										<span>
											<h6 class="modal-title"><?php echo lang('ACTIVE'); ?></h6>
										</span>
									</div>
								    <div class="pull-left vertical-line">
										<h4 data-bind="text:_project.in_active_projects"></h4>
									</div>
								</div>
							</div>
							<div class="pull-right">
								<div class="row nmr">
									<span class="pull-left">
										<h2 data-bind="hours:{val:_project.total_hours, showNull:true}" class="list-group-item-heading"></h2>
									</span>
									<span class="pull-right hrs"><?php echo lang('HRS'); ?></span>
							    </div>
							    <div class="row">
							    	<hr class="modal-title col-md-7 nm">
							    </div>
								<div class="row nmr">
									<div class="pull-left"><?php echo lang('BILLABLE'); ?></div>
									<div class="pull-right">
										<h4 data-bind="hours:{val:_project.billable, showNull:true}" class="nm np al"></h4>
									</div>
								</div>
						    </div>
						</div>
					</div>
					<div class="timeline" data-bind="foreach:_project.items">
						<div class="row block">
					   		<span class="icon-list-alt icon-metro img-circle bg-blue nb"></span>
							<div class="well nm">
								<div class="row nm">
									<div class="pull-left">
										<h4 class="no-margin" data-bind="text:project_name"></h4>
										<h6 data-bind="text:client_name" class="small gray"></h6>
									</div>
									<div class="pull-right align-right">
										<h4 data-bind="hours:{val:hours, showNull:true}" class="pull-left normal no-margin"></h4>&nbsp;
										<span style="font-weight:600;"><?php echo lang('HRS'); ?></span>
										<div class="clearfix"></div>
										<h6 data-bind="text:display_dt" class="ar small gray"></h6>
									</div>	
								</div>
							</div>
						</div>
					</div>
					<div class="row">
						<span class="label btn-success">
						<a href="javascript:;" data-bind="visible:_project.view_more, click:load_more_projects">
							<span class="btn-success"><?php echo lang('VIEW_MORE'); ?></span>
						</a>
						<a data-bind="visible:_project.loading" href="javascript:;">
							<span class="btn-success"><?php echo lang('LOADING'); ?></span>
						</a>
						<a data-bind="visible:_project.view_more()==false && _project.loading()==false" href="javascript:;">
							<span class="btn-success adc" data-bind="visible:_project.total_projects()>0"><?php echo lang('NO_MORE_DATA'); ?></span>
							<span class="btn-success adc" data-bind="visible:_project.total_projects()<=0"><?php echo lang('NO_DATA_FOUND'); ?></span>
						</a>
						</span>
					</div>
				</div>
			</div>	
		</div>
		<?php endif; ?>
	</div>
<?php
			break;
		case "activity":
			$this->load->view('comments/timeline', array('module'=>'activity', 'type'=>'users'));
			break;
	}
?>
