(function(Otime){

	Otime.MyTasks = new function MyTasks(){
		// "use strict";

		var _this	= this;

		_this.name	= "tasks";

		_this.model	= "MyTasksListModel";

		_this.language	= "tasks";

		_this.appModel	= null;

		_this.details	= {
			all_users: {},
			projects: {},
			task_status: {},
			task_types: {},
			project_users: {},
			project_task_types: {},
			followers: {}
		};

		var flagFollowers	= false;
		_this.MyTasksListModel	= function(data){
			var self	= this;

			data	= data || {};

			var is_On_Load	= false;

			self.filters	= Otime.o({});

			self.task_status	= Otime.a([]);
			self.task_types		= Otime.a([]);

			self.is_detail		= Otime.o(false);

//			self.show_details	= function(item){
//				self.is_detail(true);
//				if (item && item.rp)
//				{
//					// item.rp().is_all(false);
//					item.rp().onChangePane(-1)();
//				}
//			};

			self.swapDetails	= function(){
				/*
				if (!self.rp_min_view() && !self.is_detail())
				{
					self.rp_min_view(true);
					return;
				}*/

				if (self.is_detail())
				{
					self.is_detail(false);
					self.rp_min_view(true);
				}
				else
				{
					self.is_detail(true);
					self.rp_min_view(false);
				}
			};

			self.get_users	= function(project_id){
				var ret	= [];
				ret.push({user_id:0,first_name:"Any User",last_name:"",user_image:"",is_active:1});
				$.each(_this.details.project_users[project_id()], function(key, val){
					ret.push(_this.details.all_users[val]);
				});
				return ret;
			};

			self.get_tasktypes	= function(project_id){
				var ret	= [];
				$.each(_this.details.project_task_types[project_id()], function(key, val){
					ret.push(_this.details.task_types[val]);
				});
				return ret;
			};

			self.filter	= Otime.o(Otime.Storage.get("mytasks_filter", "over_due"));

			self.selectFilter	= function(item){
				self.filter(item.key);
			};
			self.trig_load	= true;
			self.filter.subscribe(function(newVal){
				if (!newVal || newVal === "undefined")
				{
					return false;
				}

				self.selectedItem(null);
				Otime.Storage.set("mytasks_filter", newVal);
				self.trig_load && self.loadData(is_On_Load);
				self.trig_load	= true;
				is_On_Load	= false;
			});

			self.listing	= Otime.a([]);
			self.selectedItem	= Otime.o();

			var is_details_loaded	= false;
			self.loadDetails	= function(clbk){
				if (is_details_loaded)
				{
					typeof clbk === "function" && clbk();
					return;
				}

				Otime.app.loadData(new Otime.ContextModel("mytasks_details", {
				}, function(cont){
					var resp	= cont.response;
					is_details_loaded	= true;

					var filters	= {
						"over_due": {
							key: "over_due",
							count: Otime.o(0),
							value: "Overdue",
							is_visible: Otime.o(true)
						},
						"due_today":{
							key: "due_today",
							count: Otime.o(0),
							value: "Due Today",
							is_visible: Otime.o(true)
						},
						"due_week":{
							key: "due_week",
							count: Otime.o(0),
							value: "Due This Week",
							is_visible: Otime.o(true)
						}
					};

					if (resp.all_users && resp.all_users.otvalues)
					{
						_this.details.all_users	= resp.all_users.otvalues.setKeys(resp.all_users.otkeys, null, "user_id");
					}

					if (resp.projects && resp.projects.otvalues)
					{
						_this.details.projects	= resp.projects.otvalues.setKeys(resp.projects.otkeys, null, "project_id");
					}

					if (resp.task_status && resp.task_status.otvalues)
					{
						_this.details.default_status	= "";
						var style	= "<style type='text/css'>";
						var rule	= ".mytasks .filters.ft##ID##{background-color:##BGCOLOR##;border-bottom-color:##BGCOLOR##;color:##FGCOLOR##;}.mytasks .filters.ft##ID##.active{color:##BGCOLOR##;}";
						_this.details.task_status	= resp.task_status.otvalues.setKeys(resp.task_status.otkeys, function(itm){
							// Default Status
							if (itm.is_default-0)
							{
								_this.details.default_status	= itm.task_status_id-0;
							}
							// Open Status
							if ((itm.system_defined-0) && !(itm.is_closed-0))
							{
								_this.details.open_status	= itm.task_status_id-0;
							}
							// Closed Status
//							if (!!(itm.is_closed-0))
//							{
//								_this.details.close_status	= itm.task_status_id-0;
//							}

							if (!(itm.is_closed-0))
							{
								filters[itm.task_status_id-0]	= {
									key: itm.task_status_id-0,
									count: Otime.o(0),
									value: itm.name,
									is_visible: Otime.o(false)
								};
								style	+= rule.replace(/##ID##/g, itm.task_status_id).replace(/##BGCOLOR##/g, itm.bg_color).replace(/##FGCOLOR##/g, itm.text_color);
							}
						}, "task_status_id");

						self.task_status(Object.values(_this.details.task_status));
						style	+= "</style>";
						$(style).appendTo("head");
					}

					self.filters(filters);

					if (resp.task_types && resp.task_types.otvalues)
					{
						_this.details.task_types	= resp.task_types.otvalues.setKeys(resp.task_types.otkeys, null, "task_type_id");
					}

					if (resp.project_users)
					{
						_this.details.project_users	= {};
						$.each(resp.project_users, function(key, val){
							_this.details.project_users[key]	= val.split(",");
						});
					}

					if (resp.project_task_types)
					{
						_this.details.project_task_types	= {};
						$.each(resp.project_task_types, function(key, val){
							_this.details.project_task_types[key]	= val.split(",");
						});
					}

//					self.filter(Otime.Storage.get("mytasks_filter", "over_due"));

					typeof clbk === "function" && clbk();
				}));
			};

			var toggleView	= function(isHide){
				$("#mytasks-container")[isHide ? "hide" : "show"]();
			};
			self.loadData	= function(isOnLoad){
				is_On_Load	= isOnLoad;
				self.loadDetails(function(){
					var postData	= {
						filter: self.filter()
					};
					if (is_On_Load)
					{
						postData.onload	= 1;
						is_On_Load	= false;
					}
					Otime.app.loadData(new Otime.ContextModel("mytasks_listing", postData, function(cont){
						var resp	= cont.response;
						var filters	= self.filters();
						if (resp.filter && resp.filter != self.filter())
						{
							self.trig_load	= false;
							self.filter(resp.filter);
						}

						filters["over_due"].count(resp.counts.over_due-0);
						filters["due_today"].count(resp.counts.due_today-0);
						filters["due_week"].count(resp.counts.due_this_week-0);

						if (resp.followers)
						{
							_this.details.followers	= resp.followers;
						}

						if (resp.counts.status && resp.counts.status.otvalues)
						{
							resp.counts.status	= resp.counts.status.otvalues.setKeys(resp.counts.status.otkeys, null, "task_status_id");
							var tmp	= null;
							$.each(self.filters(), function(key, val){
								tmp	= resp.counts.status[val.key];
								if (tmp)
								{
									val.count(tmp.count-0);
									val.is_visible(true);
								}
								else if(val.key > 3)
								{
									val.is_visible(false);
								}
							});
/*
							var key	= self.filter();
							if (filters[key])
							{
								filters[key].count(resp.counts.status[_this.details.open_status]-0);

								var activeCnt	= 0,
								tmpStatus	= null;

								for (var i=0,st=Object.keys(_this.details.task_status),iLen=st.length; i<iLen; i++)
								{
									tmpStatus	= _this.details.task_status[st[i]];
									if (!(tmpStatus.is_closed-0) && resp.counts.status[st[i]])
									{
										activeCnt	+= (resp.counts.status[st[i]]-0);
									}
								}
								filters[key].count(activeCnt);
							}
*/
						}
						self.filters(filters);

						if (resp.cur_time)
						{
							Otime.TimeSheet.curTime = resp.cur_time;
							Otime.Menu.curTime = resp.cur_time;
						}

						var buildList	= function(list){
							if (!list.otvalues)
							{
								self.listing([]);
								return;
							}
							var arr	= [];
							list.otvalues.setKeys(list.otkeys, function(val){
								if (resp.timesheet && resp.timesheet.project_task_id && val.task_id	== resp.timesheet.project_task_id)
								{
									resp.timesheet.cur_time	= resp.cur_time;
									val.timesheet	= resp.timesheet;
								}
								arr.push(new _this.MyTasksContentModel(val, self));
							});
							self.listing(arr);
						};

						switch(self.filter())
						{
							case "over_due":
								resp.over_due && buildList(resp.over_due);
								break;
							case "due_today":
								resp.due_today && buildList(resp.due_today);
								break;
							case "due_week":
								resp.due_this_week && buildList(resp.due_this_week);
								break;
							default:
								resp.status && buildList(resp.status);
								break;
						}

						0 < self.listing().length && self.edit(self.listing()[0]);
						toggleView(false);
					}));
				});
			};

			self.rp_min_view	= Otime.o(true);
			self.toggle_rpview	= function(item){
				self.rp_min_view(!self.rp_min_view());
			};

			var start	= function(time_sheet_id, item){
				if (!time_sheet_id)
				{
					return false;
				}

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/start', {
					time_sheet_id : time_sheet_id
				}, function(cont){
					var resp = cont.response;

					Otime.TimeSheet.curTime = resp.cur_time;
					Otime.Menu.curTime = resp.cur_time;

					var tmpTimeSheet	= item.timesheet();
					tmpTimeSheet.time_sheet_id	= tmpTimeSheet.time_sheet_id || time_sheet_id;
					tmpTimeSheet.entry_date	= Otime.o(Otime.Date().format(Otime.jdf));
					tmpTimeSheet.hours	= Otime.o(tmpTimeSheet.hours()-0);
					tmpTimeSheet.is_running	= Otime.o(true);
					tmpTimeSheet._info	= {
						hours_disp: Otime.o("")
					};
					item.timesheet(tmpTimeSheet);

					Otime.TimeSheet.SetInterval(resp.time, item.timesheet(), (Number(tmpTimeSheet.hours()) * 60 * 60), 'HH:NN<sub>SS</sub>');

//					Otime.TimeSheet.SetInterval(cell._info.from_time, cell, (Number(cell.hours()) * 60 * 60), 'HH<span class="blink">:</span>NN');

					Otime.Menu.activeTask = {
						time_sheet_id : resp.time_sheet_id,
						activity_name : item.name,
						project_name : item.project_name,
						is_progress : true,
						from_time : resp.time,
						hours : 0
					};
					Otime.Menu.initProgress();

				}), true);
			};

			var stop	= function(time_sheet_id, item, clbk){
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/timesheet/stop', {
					time_sheet_id : time_sheet_id
				}, function(cont){
					var resp = cont.response;

					var ts	= item.timesheet();
					ts.is_running(false);
					Otime.app.running_process(null);
					var prog	= Otime.Menu.progress();
					if (prog)
					{
						prog.hours(resp.hours);
						prog.time_sheet_id(resp.time_sheet_id);
						resp.entry_date && prog.entry_date(Otime.stoj(resp.entry_date).format(Otime.jdf));
					}
					Otime.TimeSheet.ClearInterval();
					ts._info.hours_disp("");
					ts.is_running(false);
				}), true);
			};

			self.start	= function(item){
				if (!(item.task_type_id()-0))
				{
					alert("Task Type required.");
					return false;
				}

				if (item.timesheet().time_sheet_id)
				{
					if (item.timesheet().is_running())
					{
						stop(item.timesheet().time_sheet_id, item);
					}
					else
					{
						start(item.timesheet().time_sheet_id, item);
					}
					return false;
				}

				var data	= {
					entry_date: Otime.Date().format(Otime.sdf),
					project_id: item.project_id,
					task_type_id: item.task_type_id,
					project_task_id: item.task_id,
					time_sheet_id: 0,
					count: 0,
					hours: 0,
					haveDetails: false,
					activity_name: item.name,
					direct_entry: 0
				};

				Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/timesheet/save", data, function(cont){
					if (cont.response && cont.response[0].time_sheet_id)
					{
//						cell.time_sheet_id(cont.response[0].time_sheet_id);
						start(cont.response[0].time_sheet_id, item);
					}
				}), true);
			};

			var _INITIALIZE_COMMENTS	= function(item, clbk){
				new Otime.Comments.init({
					module_type: "T",
					module_id: item.task_id(),
					elem: "",
					parent: self,
					model: item,
					onToggleMinimize: function(isMin){
						self.rp_min_view(isMin);
					},
					isSeparate: true,
					dropZone : "#comments-container",
//					fileApi_buttonValue: '&nbsp;', // '<span class="icon icon-paper-clip"></span>',
//					fileApi_buttonClass: 'dn',
					fileApi_buttonClass: 'blue anchor',
					noBind: true,
					onAddFile: function(newAttachItem){
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
					onPaneChange: function(newVal){
						self.is_detail(newVal <= 0 ? true : false);
					},
					clbk: clbk
				});
			};

			self.showComments	= function(item){
				_INITIALIZE_COMMENTS(item, function(module){
					module.paneType(module.paneTypes.COMMENT);
				});
				self.selectedItem(item);
				self.rp_min_view(false);
			};

			self.showAttachments	= function(item){
				_INITIALIZE_COMMENTS(item, function(module){
					module.paneType(module.paneTypes.DOCUMENT);
				});
				self.selectedItem(item);
				self.rp_min_view(false);
			};

			self.edit	= function(item){
				_INITIALIZE_COMMENTS(item);
				self.selectedItem(item);
			};

			self.save	= function(item){
				_this.taskSave(item, self.rp_min_view());
			};
		};

		_this.taskSave	= function(item, is_min_view){
			var postData	= {
				project_id: item.project_id(),
				items: []
			};

			if (item.followers().indexOf(item.assignee_id()+"") < 0)
			{
				flagFollowers	= true;
				item.followers.push(item.assignee_id());
				flagFollowers	= false;
			}

			var data	= {task_id: item.task_id()};
			if (item.task_status_id.isDirty())
				data.task_status_id	= item.task_status_id();
			if (item.assignee_id.isDirty())
				data.assignee_id	= item.assignee_id();
			if (item.followers.isDirty())
				data.followers	= item.followers();
			if (item.description.isDirty())
				data.description	= item.description();
			if (item.finish_date.isDirty())
				data.finish_date	= new Date(item.finish_date()).format(Otime.sdf);
			if (item.start_date.isDirty())
				data.start_date	= new Date(item.start_date()).format(Otime.sdf);
			if (item.duration.isDirty())
				data.duration	= item.duration();

			if (!is_min_view)
			{
				if (item.name.isDirty())
					data.name	= item.name();
				if (item.task_type_id.isDirty())
					data.task_type_id	= item.task_type_id();
				if (item.percentage_complete.isDirty())
					data.percentage_complete	= item.percentage_complete();
				if (item.task_priority.isDirty())
					data.task_priority	= item.task_priority();
				if (item.estimated_hours.isDirty())
					data.estimated_hours	= item.estimated_hours();
			}
			postData.items.push(data);

			Otime.app.postData(new Otime.ContextModel(Otime.siteUrl + "/tasks/save", postData, function(cont){
				item.task_status_id.update();
				item.assignee_id.update();
				item.followers.update();
				item.description.update();
				item.name.update();
				item.task_type_id.update();
				item.percentage_complete.update();
				item.task_priority.update();
				item.estimated_hours.update();

//				if (cont.response)
//				{
//					 console.log(cont.response);
//				}
			}), true);
		};

		_this.MyTasksContentModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self.org_data	= data;

			data.timesheet	= data.timesheet || {};

			self.task_id		= Otime.o(data.task_id || "");
			self.name			= Otime.o(data.name || "").extend({
				taskChange : true
			});
			self.description	= Otime.o(data.description || "").extend({
				taskChange : true
			});
			self.description.subscribe(function(){
				!parent.is_detail() && parent.save(self);
			});
			self.task_number	= Otime.o(data.task_number || "");
			self.project_id		= Otime.o(data.project_id || "");
			self.task_type_id	= Otime.o(data.task_type_id || "").extend({
				taskChange : true
			});
			self.percentage_complete	= Otime.o(data.percentage_complete || "").extend({
				taskChange : true
			});
			self.worked_hours	= Otime.o(data.worked_hours || "");

			self.task_priority	= Otime.o(data.task_priority || 2).extend({
				taskChange : true
			});
			self.estimated_hours	= Otime.o(data.estimated_hours || "").extend({
				taskChange : true
			});
			self.is_milestone	= Otime.o(!!(data.is_milestone-0)).extend({
				taskChange : true
			});
			var flagD = false, flagS = false, flagF = false;
			self.duration	= Otime.o(data.duration || "").extend({
				taskChange : true
			});
			self.duration.subscribe(function(newVal){
				if (flagD)
				{
					return;
				}

				if (self.start_date())
				{
					var finish	= null;
					finish	= new Date(self.start_date());
					finish.addDays(self.duration()-0);

					flagF=true;
					self.finish_date(finish);
					flagF=false;
				}

				!parent.is_detail() && parent.save(self);
			});
			self.start_date		= Otime.o(Otime.stoj(data.start_date)).extend({
				taskChange : true
			});
			self.start_date.subscribe(function(newVal){
				var start	= new Date(self.start_date());
				start.addDays(self.duration()-0);

				flagF	= true;
				self.finish_date(start);
				flagF	= false;

				!parent.is_detail() && parent.save(self);
			});
			self.finish_date	= Otime.o(Otime.stoj(data.finish_date)).extend({
				taskChange : true
			});
			var fDt	= new Date(self.finish_date());
			self.is_over_due	= Otime.o(fDt.isPast() && !fDt.isToday());

			self.finish_date.subscribe(function(newVal){
				var finish	= new Date(self.finish_date());
				self.is_over_due(finish.isPast() && !finish.isToday());

				if (flagF)
				{
					return;
				}

				if (self.start_date())
				{
					var start	= new Date(self.start_date());
					var diff	= (finish-start)/(1000*60*60*24);

					flagD=true;
					if (diff > 0)
					{
						self.duration(diff);
					}
					else
					{
						self.duration("");
					}
					flagD=false;
				}

				!parent.is_detail() && parent.save(self);
			});

			self.created_by		= Otime.o(_this.details.all_users[data.created_by].first_name);
			self.has_attachments	= Otime.o(!!(data.has_attachments-0));
			self.has_comments	= Otime.o(!!(data.has_comments-0));

			var tmp	= _this.details.projects[data.project_id] || {};
			self.project_name	= Otime.o(data.project_name || tmp.project_name || "");
			self.project_color	= Otime.o(data.bg_color || tmp.bg_color || "");

			tmp	= "";
			if (!!(self.task_type_id()-0))
			{
				tmp	= _this.details.task_types[self.task_type_id()].name;
			}
			self.task_type_name	= Otime.o(tmp);

			self.task_status_id	= Otime.o(data.task_status_id || "").extend({
				taskChange : true
			});
			self.task_status_id.subscribe(function(newVal){
				self.task_status(_this.details.task_status[newVal] || {});
				parent.save(self);
			});
			tmp	= _this.details.task_status[data.task_status_id || _this.details.default_status];
			self.task_status	= Otime.o(tmp || {});

			var followers = data.followers || $.unique(_this.details.followers[data.task_id].split(",") || []);
			self.followers		= Otime.a(followers).extend({
				taskChange : true
			});
			self.followers_disp	= Otime.o("");
			var setFollowersDisp	= function(newVal){
				if (newVal)
				{
					newVal	= $.unique(newVal);
					var tmp	= "", res=[];
					var followers = self.followers();
					for (var i=0, iLen=followers.length; i<iLen; i++)
					{
						tmp	= _this.details.all_users[followers[i]];
						tmp && tmp.first_name && res.push(tmp.first_name);
					}
					self.followers_disp(res.join(", "));
				}
			};
			
			self.followers.subscribe(function(newVal){
				setFollowersDisp(newVal);
				!flagFollowers && !parent.is_detail() && parent.save(self);
			});
			setFollowersDisp(self.followers());
			self.assignee_id	= Otime.o(data.assignee_id || "").extend({
				taskChange : true
			});
			self.assignee	= Otime.o("");
			var setAssignee	= function(newVal){
				tmp	= _this.details.all_users[newVal];
				self.assignee(tmp ? tmp.first_name : "");
				if (self.followers().indexOf(newVal) < 0)
				{
					flagFollowers	= true;
					self.followers.push(newVal);
					flagFollowers	= false;
				}
				return true;
			};
			self.assignee_id.subscribe(function(newVal){
				setAssignee(newVal) && !parent.is_detail() && parent.save(self);
			});
			setAssignee(self.assignee_id());

			self.worked_hours	= Otime.o(data.worked_hours);

			var tooltip	 = "";
			tooltip		+= (!data.start_date || data.start_date == "0000-00-00" || data.start_date == "0000-00-00 00:00:00") ? "" : ("Start Date		:  " + Otime.stoj(data.start_date).format(Otime.dateFormat) + "\n");
			tooltip		+= (!data.finish_date || data.finish_date == "0000-00-00" || data.finish_date == "0000-00-00 00:00:00") ? "" : ("Finish Date	:  " + Otime.stoj(data.finish_date).format(Otime.dateFormat) + "\n");
			tooltip		+= !(data.duration-0) ? "" : "Duration		:  " + (data.duration + "\n");
			tooltip		+= !data.estimated_hours ? "" : ("Estimated Hrs	:  " + data.estimated_hours + "\n");
			tooltip		+= !data.worked_hours ? "" : ("Actual Hrs	:  " + data.worked_hours + "\n");

			self.tooltip	= Otime.o(tooltip);

			self.is_ts_running	= Otime.o(false);
			self.rp				= Otime.o(null);// Right pane comments,attach,activities

			var entry_date	= data.timesheet.entry_date ? Otime.stoj(data.timesheet.entry_date) : new Date();
			self.timesheet	= Otime.o({
				time_sheet_id: data.timesheet.time_sheet_id || 0,
				entry_date: Otime.o(entry_date.format(Otime.jdf)),
				hours: Otime.o((data.timesheet.hours || 0)-0),
				is_running: Otime.o(data.timesheet.time_sheet_id ? true : false),
				entry_detail: data.timesheet.entry_detail,
				_info: {
					hours_disp: Otime.o("")
				}
			});

			if (data.timesheet.time_sheet_id)
			{
				Otime.TimeSheet.SetInterval(data.timesheet.entry_detail.from_time, self.timesheet(), (Number(self.timesheet().hours()) * 60 * 60), 'HH:NN<sub>SS</sub>');

				Otime.Menu.activeTask = {
					time_sheet_id : self.timesheet().time_sheet_id,
					activity_name : self.name(),
					project_name : self.project_name(),
					is_progress : true,
					from_time : data.timesheet.entry_detail.from_time,
					hours : self.timesheet().hours()
				};
				Otime.Menu.initProgress();
			}

		};

		_this.showTask	= function(task_id, project_id, appModel){
			if (!task_id || !project_id || !appModel)
			{
				return false;
			}

			Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/tasks/item", {
				project_id: project_id,
				task_id: task_id,
				module: "TS"
			}, function(cont){
				var resp	= cont.response;
				var data = resp.item;

				if (resp.users && resp.users.otvalues && Object.keys(resp.users.otvalues).length > 0)
				{
					var _users	= {"0":{
						user_id: 0,
						first_name: "Any User",
						is_active: "1",
						last_name: "",
						user_role: "",
						user_image: ""
					}};
					resp.users	= resp.users.otvalues.setKeys(resp.users.otkeys, function(val){
						val.user_image	= Otime.USIP + (val.user_image || "no_user.jpg");
						if (!!(val.is_active-0))
						{
							_users[val.user_id]	= val;
						}
					}, "user_id");
					resp.users	= _users;
				}

				if (resp.all_users && resp.all_users.otvalues && Object.keys(resp.all_users.otvalues).length > 0)
				{
					_this.details.all_users	= resp.all_users.otvalues.setKeys(resp.all_users.otkeys, null, "user_id");
				}

				if (resp.task_status && Object.keys(resp.task_status).length > 0)
				{
					resp.task_status	= resp.task_status.otvalues.setKeys(resp.task_status.otkeys, function(val, key){
//						if (!!(val.is_default-0)) {
//							_this.appModel.default_status	= val.task_status_id;
//						}
//						if (val.is_closed-0) {
//							_this.appModel._info.closedStatusId	= val.task_status_id;
//						}
					}, "task_status_id");	
					_this.details.task_status	= resp.task_status;
					appModel.task_status(Object.values(resp.task_status));
				}

				if (resp.task_types && Object.keys(resp.task_types).length > 0)
				{
					resp.task_types	= resp.task_types.otvalues.setKeys(resp.task_types.otkeys, function(val){
						val.label	= val.name;
						val.value	= val.name;
						val.id	= val.task_type_id;
					}, "task_type_id");
					_this.details.task_types	= resp.task_types;
				}

				var taskObj	= new function(){
					var self	= this;
					self.isPane	= Otime.o(true);
					self.is_pinned	= Otime.o(true);
					self.swapPane	= function(){
						appModel.isRightPane(false);
						appModel.task_detail(null);
					};
					self.swapDetails	= function(){
						if (taskObj.is_detail())
						{
							taskObj.is_detail(false);
							taskObj.rp_min_view(true);
						}
						else
						{
							taskObj.is_detail(true);
							taskObj.rp_min_view(false);
						}
					};
					self.showTimeLine	= function(){
					};
					self.task_status	= Object.values(resp.task_status);
					self.get_tasktypes	= function(project_id){
						return Object.values(resp.task_types);
					};
					self.get_users	= function(project_id){
						// ret.push({user_id:0,first_name:"Any User",last_name:"",user_image:"",is_active:1});
						return Object.values(resp.users);
					};
					self.save	= function(item){
						_this.taskSave(item, self.rp_min_view());
					};

					self.selectedItem	= Otime.o(new _this.MyTasksContentModel(data, self));
					self.rp_min_view	= Otime.o(true);
					self.is_detail	= Otime.o(false);
				};

				var targ = taskObj.selectedItem();
				new Otime.Comments.init({
					module_type: "T",
					module_id: task_id,
					parent: taskObj, //_this.appModel,
					model:targ,
					isSeparate: true,
					noBind: true,
					//fileApi_buttonValue: '<span class="icon icon-paper-clip blue"></span>',
					fileApi_buttonClass: 'blue anchor',
					onAddFile: function(newAttachItem){
						newAttachItem && newAttachItem.save && newAttachItem.save();
					},
					onToggleMinimize: function(isMin){
						taskObj.is_detail(false);
						taskObj.rp_min_view(isMin);
					}
				});

				appModel.isRightPane(true);
				appModel.task_detail(taskObj);
			}), true);
		};

		_this.UpdateContainers	= function(){
			_this.bodyCont		= $("#body-container");
			_this.myTasksCont	= $("#mytasks-container");
		};

		_this.loadTemplates	= function(clbk){
			typeof clbk === "function" && clbk();
		};

		_this.Refresh	= function(){
			_this.appModel.loadData(true);
		};

		_this.init	= function(){
			_this.UpdateContainers();

			_this.appModel = new _this.MyTasksListModel();

			ko.applyBindings(_this.appModel, _this.myTasksCont.get(0));

			_this.Refresh();
		};
	};

}(window.Otime));
