﻿(function(Otime){

	Otime.TimeSheet	= new function TimeSheet(){
//		"use strict";

		var _this	= this;

		_this.name	= "timesheet";

		_this.model	= "TimeSheetViewModel";

		_this.language	= null;

		_this.projects	= null;

		_this.tasks	= null;

		_this.searchArray	= null;

		_this.popupBind	= null;

		_this.curTime	= null;

		_this.members	= [];

		var info_loaded	= false;

		_this.timerTmpl	= {
			_default: "HH : NN : SS",
			week: "HH:NN<sub>SS</sub>",
			day: "HH:NN<sub>SS</sub>"
//			day: "HH : NN : SS"
		};

		_this.save	= null;

		_this.cancel	= null;

		_this.Views	= {
			DAY_VIEW: 0,
			WEEK_VIEW: 1,
			CALENDAR_VIEW: 2
		};

		_this.Start	= function(time_sheet_id){
			if (!time_sheet_id)
			{
				return;
			}

			var view	= _this.appModel.getCurrentView();

			if (_this.appModel.view() == _this.Views.DAY_VIEW && view.items().length > 0)
			{
				$.each(view.items()[0].listing(), function(key, val){
					if (val.time_sheet_id() == time_sheet_id)
					{
						view.items()[0].start(val);
						return false;
					}
				});
			}

			if (_this.appModel.view() == _this.Views.WEEK_VIEW && view.listing().length > 0)
			{
				for (var list = view.listing(), len=list.length, i=0; i<len; i++)
				{
					for (var hrsList = list[i].hours_list_week(), hrsLen= hrsList.length, j=0; j < hrsLen; j++)
					{
						if (hrsList[j].time_sheet_id() == time_sheet_id)
						{
							list[i].start();
							i = len; // for break 1st for loop
							break;
						}
					}
				}
			}

			if (_this.appModel.view() == _this.Views.CALENDAR_VIEW)
			{
				view.start(time_sheet_id);
			}
		};

		_this.Stop	= function(cont){
			var process = Otime.app.running_process();
			if (!process)
			{
				console.log("Process not avail.");
				return;
			}

			if (typeof process.stop == "function")
				process.stop(null, null, cont);
			else if(process.getParent && process.getParent().stop)
				process.getParent().stop(null, null, cont);
			else if(Otime.app && Otime.app.model && Otime.app.model.start)	// Task page timesheet start stop.
				Otime.app.model.start(process, null, cont);
		};

		_this.TimeSheetViewModel	= function(data){
			var self	= this;

			data	= data || {};

//			_this.Views.DAY_VIEW;
//			_this.Views.WEEK_VIEW;
//			_this.Views.CALENDAR_VIEW;

			if (Otime.Storage.get("timesheet_view") === undefined)
			{
				Otime.Storage.set("timesheet_view", _this.Views.DAY_VIEW);
			}

			var defaultView	= Otime.Storage.get("timesheet_view")-0;

			// Due to issue in calendar load.
//			defaultView	= (defaultView==_this.Views.CALENDAR_VIEW) ? _this.Views.DAY_VIEW : defaultView;

			self.view	= Otime.o(defaultView);

			self.day_view		= Otime.o(null);
			self.week_view		= Otime.o(null);
			self.calendar_view	= Otime.o(null);

			self.loadDefault	= Otime.o(null);

			self.active_item	= Otime.o(null);
			self.active_parent	= Otime.o(null);

			self.users_list	= Otime.a([]);
			self.sel_user		= Otime.o(Otime.UID);
			self.sel_user.subscribe(function(newVal){
				self.load_view();
			});

			self.getCurrentView	= function(){
				return self[["day_view", "week_view", "calendar_view"][self.view()]]();
			};

			// Task pane vars
			self.isRightPane	= Otime.o(false);
			self.task_detail	= Otime.o();
			self.task_types	= Otime.o();
			self.task_status	= Otime.o();

			self.projects	= Otime.a([]);

			self.act_pro	= Otime.a([]);

			var hideFn	= function(e){
				if (e.target.tagName == "TEXTAREA" || $(e.target).is(".notes"))
				{
					return;
				}
				$('#add-notes').css({
					'top': -999,
					'left': -999
				}).hide();
				$('#add-notes textarea').val("");
			};
			self.showNotes	= function(item, elem){
				if (elem.is(".future") || !(item.time_sheet_id()-0) || item.count()>1)
				{
					return false;
				}
				$('#add-notes').css({
					'position': 'absolute',
					'top': elem.position().top,
					'left': elem.position().left
				}).show();
				$('html').unbind("click", hideFn).on('click', hideFn);
				$('#add-notes textarea').val(item.notes()).unbind('keypress').keypress(function(ke){
					if (ke.keyCode == 27)
					{
						$('html').trigger("click");
						return false;
					}
					else if (ke.keyCode == 13 && !ke.shiftKey)
					{
						item.notes(this.value);
						var data	= {
							time_sheet_id: item.time_sheet_id(),
							notes: item.notes()
						};
						Otime.app.postData(new Otime.ContextModel({
							url: "save_notes",
							global: false
						}, data, function(cont){
							var response	= cont.response;
							$('html').trigger("click");
						}));
						return false;
					}
					return true;
				}).focus();
				return true;
			};
			
			self.initScrollEvent	= function(){
				var scrElem	= $("#main-container");
				scrElem.unbind("scroll");

				if (self.view() == _this.Views.WEEK_VIEW)
				{
					var item	= null, elem	= null;
					$("#week_list tbody").contextmenu({
						target: '#context-menu',
						before: function(e, context){
							item	= null;
							var targ	= $(e.target);
							if (targ.is('tr td:first-child *, tr td:last-child *'))
							{
								this.closemenu();
								return false;
							}
							else
							{
								elem	= targ;
								if (!targ.is('td'))
								{
									elem	= targ.parent();
								}
								item	= ko.dataFor(e.target);
							}
							$('#ts_notes').show();
							if (!item.time_sheet_id()) {
								$('#ts_notes').hide();
							}
						},
						onItem: function(context, e){
							switch($(e.target).attr('action'))
							{
								case 'notes':
									self.showNotes(item, elem);
									break;
								case 'edit':
									item.getParent().edit(item, elem);
									break;
							}
							
						}
					});
				}

				return true;
/*
				if (self.view() == _this.Views.DAY_VIEW)
				{
					scrElem.scroll(function(){
						if($("#timesheet-container").height() == ($(this).scrollTop()+$(this).height()))
						{
							_this.appModel.day_view().load_more();
						}
					});
				}
*/
			};

			var _details	= [["TSDListModel", "day_view"], ["TimeSheetWeekModel", "week_view"], ["TimeSheetCalendarModel", "calendar_view"]];
			self.swap_view	= function(view){
				view	= typeof view != "undefined" ?  view-0 : (Otime.Storage.get("timesheet_view")-0);
				return function(){
					var curDate	= self[_details[self.view()][1]]();
					curDate	= curDate ? curDate.current_date() : new Date();
					self.view(view);
					var details	= _details[self.view()-0];

					self.day_view(null);
					self.week_view(null);
					self.calendar_view(null);

					self[details[1]](new _this[details[0]]({
						current_date: curDate
					}));
					_this.Render(self[details[1]](), function(){
						Otime.Storage.set("timesheet_view", self.view()-0);
					});
					self.initScrollEvent();

					// Close right panel
					_this.appModel.task_detail().swapPane();
				};
			};

			self.refresh_view	= function(){
				if (self.view() == 1)
				{
					self.load_view();
					return;
				}

				var details	= _details[self.view()-0];
				details	= self[details[1]]();
				details && details.refreshToday && details.refreshToday();
			};

			self.load_view	= function(){
				_this.loadFilters(self.sel_user());

				var details	= _details[self.view()-0];

				self[details[1]](new _this[details[0]]());

				if (typeof self[details[1]]().current_date() == "string")
					self[details[1]]().current_date(self[details[1]]().current_date().replace(/-/g, "/"));

				_this.Render(self[details[1]]());
				self.initScrollEvent();
			};
		};

		_this.ClearInterval	= function(){
			if (!Otime.timerInstance || !Otime.timerInstance.length)
			{
				Otime.timerInstance	= [];
				Otime.Menu.progress() && Otime.Menu.progress()._info && Otime.Menu.progress()._info.is_running(false);
				Otime.Menu.isNotRunning(true);
				return true;
			}

			if (typeof Otime.timerInstance == "number")
			{
				clearInterval(Otime.timerInstance);
			}
			else
			{
				var len	= Otime.timerInstance.length;
				for(var i=0; i<len; i++)
				{
					clearInterval(Otime.timerInstance[i]);
				}
			}
			Otime.timerInstance	= [];
			Otime.Menu.progress() && Otime.Menu.progress()._info && Otime.Menu.progress()._info.is_running(false);
			Otime.Menu.isNotRunning(true);
		};

		_this.SetInterval	= function(startTime, item, addSeconds, tmpl, parent, clbk){
//			addSeconds = Number(addSeconds) || 0;

//			if (addSeconds)
//				addSeconds	= Math.floor(addSeconds/60)*60;

			var matches	= startTime.match(/^(\d+):(\d+):(\d+) (AM|PM)/);
			if (!matches)
			{
				console.log("Invalid start time matches.");
				return false;
			}

			// Today date
			item._info.tstamp	= Otime.Date();

			// timer start date.
			startTime	= new Date(item.entry_date() + " " + startTime);
//			startTime	= new Date(item._info.tstamp.format("YYYY/MM/DD") + " " + startTime);
			if (startTime.toString() == "Invalid Date")
			{
				console.log("Invalid Date");
				return false;
			}

//			startTime	= matches[1] + ":" + matches[2] + ":" + matches[3] + " " + matches[4];
			var tod		= new Date(Math.floor(Otime.Date().getTime()/1000)*1000);
			var diff	= Math.floor((new Date(tod.format("YYYY/MM/DD")+" "+_this.curTime).getTime() - tod.getTime())/1000);

//			if (!isNaN(diff) && diff > 0)
//			{
//				addSeconds	+= diff;
//			}

//			if (addSeconds != 0)
//			{
//				startTime	= jhelper.addSeconds(startTime, -addSeconds).format("HH:NN:SS a/p");
//				startTime	= startTime.addSeconds(-addSeconds);
//			}

			tmpl	= tmpl || _this.timerTmpl._default || "HH : NN : SS";

//			item.hours(item.hours()-0);
//			startTime.addHours(-item.hours()-0);
//			startTime.addSeconds(-(item.hours()-0)*60*60);

			var hrs = item.hours() - 0;
			var minutes = Math.round((hrs % 1)*60);
			hrs = hrs - (hrs% 1);
			startTime.addHours(-hrs);
			startTime.addMinutes(-minutes);
			startTime.addSeconds(-diff);

			Otime.timerInstance	= Otime.timerInstance || [];

//			var tsDiff	= jhelper.getTimeDiffObj(startTime, item._info.tstamp.format("HH:NN:SS a/p"));
			var tsDiff	= jhelper.getTimeDiff(startTime, item._info.tstamp);

			var hrs		= Math.floor((tsDiff.days-0) * 24);
			tsDiff.total_hours	= hrs;
			item._info.hours_disp(tmpl.replace("HH", hrs).replace("NN", tsDiff.minutes).replace("SS", tsDiff.seconds));

			parent && parent.running_hours(+parent.hours() + +tsDiff.hours + (+tsDiff.minutes/60) - +item.hours());
			clbk && clbk(item, tsDiff);

			/*if (tsDiff.is_negative)
			{
				return false;
			}*/

			Otime.timerInstance.push(setInterval(function(){
				item._info.tstamp	= item._info.tstamp.addSeconds(1);
//				tsDiff	= jhelper.getTimeDiffObj(startTime, item._info.tstamp.format("HH:NN:SS a/p"));
				tsDiff	= jhelper.getTimeDiff(startTime, item._info.tstamp);
				if (tsDiff.is_negative)
				{
					return false;
				}
				hrs		= Math.floor((tsDiff.days-0) * 24);
				tsDiff.total_hours	= hrs;
				item._info.hours_disp(tmpl.replace("HH", hrs).replace("NN", tsDiff.minutes).replace("SS", tsDiff.seconds));
				parent && parent.running_hours(+parent.hours() + +tsDiff.hours + (+tsDiff.minutes/60) - +item.hours());
				clbk && clbk(item, tsDiff);
			}, 1000));
		};

		_this.TSDListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.items	= Otime.a([]);

			self.today	= Otime.Date();

			self.is_allow	= Otime.o(false);

			if (_this.appModel.loadDefault() != null && _this.appModel.loadDefault().entry_date != "")
			{
				self.date	= Otime.o(new Date(_this.appModel.loadDefault().entry_date).format(Otime.jdf));
			}
			else
			{
				self.date	= Otime.o(data.date ? new Date(data.date).format(Otime.jdf) : self.today.format(Otime.jdf));
			}

			self.current_date	= Otime.o(data.current_date || self.date());

			/***
			 * if isFresh is false then 
			 * 		New Item will be show.
			 * else
			 * 		new Timesheet Startable item will be show.
			 * 
			 * def.atl means assigned task length
			 * 
			 */
			var _addNewItem	= function(item, isFresh, def){

				if (typeof(isFresh) != 'boolean')
					isFresh = true;

				isFresh = (item.is_today() && !Otime.isM && _this.appModel.sel_user()!=Otime.UID)?true:isFresh;

				if (_this.appModel.sel_user()==Otime.UID && item.listing().length && !item.listing()[0].time_sheet_id())
				{
					/***
					 * def	- Checking assigned tasks.
					 * def.atl	- assigned task length
					 */
					if (!def || (def && def.atl<=0))
					{
						_this.selectedItem	= item.listing()[0];
						item.listing()[0].is_fresh(isFresh);
						return false;
					}
				}

				var last	= {};
				if (item.listing().length)
				{
					last.project_id	= item.listing()[0].project_id();
					last.task_type_id	= item.listing()[0].task_type_id();
					last.is_billable	= item.listing()[0].is_billable() ? 1 : 0;
				}

				var prjId	= (def && def.project_id) ? def.project_id : (last.project_id || 0),
					ttyId	= (def && def.task_type_id) ? def.task_type_id : (last.task_type_id || 0),
					isbill	= (def && def.is_billable) ? 1 : (last.is_billable || 0);

//				if (item.listing().length)
//				{
//					prjId	= item.listing()[0].project_id();
//					ttyId	= item.listing()[0].task_type_id();
//					isbill	= item.listing()[0].is_billable()?1:0;
//				}

				var lstData	= new _this.TimeSheetDetailModel({
					entry_date: new Date(item.date()).format(Otime.jdf),
					is_fresh: Boolean(isFresh),
					is_new: true,
					task_type_id: ttyId,
					project_id: prjId,
					is_billable: isbill
				}, item);

				ko.editable(lstData);

				lstData.beginEdit();
				lstData.addHoursDetail();
				lstData._info.is_new(true);

				item.listing.splice(0, 0, lstData);

				_this.selectedItem	= lstData;
				_this.save		= item.save;
				_this.cancel	= item.cancel;

				// $("input[autofocus]").focus();

				return true;
			};

			self.loadInfo	= function(callback){
				Otime.app.is_edit_mode(false);

				var dt	= new Date(self.date());

				var postData	= {
					date: dt.format(Otime.sdf)
				};
				if (!Otime.isM)
				{
					postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
				}
				var context	= new Otime.ContextModel('listing', postData, function(cont){
					self.load({
						date: dt
					}, cont);
				});

				context.after_callback	= callback;
				Otime.app.loadData(context);

				return true;
			};

			self.refreshList	= function(){
				var dates	= {};
				$.each(self.items(), function(key, val){
					dates[val.date()]	= val;
				});

				Otime.app.loadData(new Otime.ContextModel('listing', {
					dates: Object.keys(dates)
				}, function(context){
					var data	= context.response || {};
					if (data)
					{
						var dt	= {};
						data.items.otvalues.setKeys(data.items.otkeys, function(val, key){
							if (dt[val.entry_date])
							{
								dt[val.entry_date].items.otvalues.push(data.items.otvalues[key]);
							}
							else
							{
								dt[val.entry_date]	= {
									cur_time: data.cur_time,
									items: {
										otkeys: data.items.otkeys,
										otvalues: [data.items.otvalues[key]]
									}
								};
							}
						});

						var entry_date	= "";
						$.each(dt, function(key, val){
							entry_date	= Otime.stoj(key);
							self.load({
								date: entry_date
							}, {
								response: val
							}, dates[entry_date.format(Otime.jdf)]);
						});
					}
				}));
			};

			self.refreshToday	= function(){
				var item	= null;
				
				for (var i=0, items	= self.items(), iLen=items.length; i<iLen; i++)
				{
					if (items[i].is_today())
					{
						item	= items[i];
						break;
					}
				}

				Otime.app.loadData(new Otime.ContextModel('listing', {
					date: new Date(item.date()).format(Otime.sdf)
				}, function(clbk){
					self.load({
						date: new Date(clbk.data.date)
					}, clbk, item);
				}));
			};

			self.load	= function(param, context, item){
				var data	= context.response || {};

				_this.curTime	= data.cur_time;
				Otime.Menu.curTime	= data.cur_time;

				var newTSDItem	= new _this.TimeSheetDayModel({
					date: param.date
				}, self);

				if (item)
				{
					// remove from array except 1st (new timesheet) item.
					item.listing.splice(1, item.listing().length);
					newTSDItem	= item;
				}
				else
				{
					self.items.push(newTSDItem);
				}

				var assigned_tasks	= [];
				if (data.assigned_tasks != undefined && data.assigned_tasks.otvalues != undefined)
				{
					assigned_tasks	= data.assigned_tasks.otvalues.setKeys(data.assigned_tasks.otkeys);
//					if (data.items == undefined)
//					{
//						data.items = assigned_tasks;
//					}
//					else
//					{
//						$.each(assigned_tasks, function(key, val){
//							data.items.push(val);
//						});
//					}
				}

				var lstData	= [];
				if (data.items != undefined && Object.keys(data.items).length > 0 && data.items.otvalues != undefined && data.items.otvalues.length > 0)
				{
//					var loadDefault	= _this.appModel.loadDefault();

					var prog = Otime.Menu.progress();

					data.items	= data.items.otvalues.setKeys(data.items.otkeys, function(val){
						var newItem	= new _this.TimeSheetDetailModel(val, newTSDItem);
						lstData.push(newItem);
						if (val.is_progress && val.is_progress != false)
						{
							newItem.stop	= newTSDItem.stop;
							Otime.app.running_process(newItem);
						}

//						if (prog && val.time_sheet_id == prog.time_sheet_id())
//						{
//							prog.hours(val.hours-0);
//						}

						/***
						 * Default Opened when page from Weekview group data click.
						 */
//						if (loadDefault != null && loadDefault.time_sheet_id != undefined && loadDefault.time_sheet_id == val.time_sheet_id)
//						{
//							_this.SetEditable(newItem);
//						}
					});
				}
				
				if (assigned_tasks)
				{
					$.each(assigned_tasks, function(key, val){
						var newItem	= new _this.TimeSheetDetailModel(val, newTSDItem);
						lstData.push(newItem);
						if (val.is_progress && val.is_progress != false)
						{
							newItem.stop	= newTSDItem.stop;
							Otime.app.running_process(newItem);
						}
					});
				}

				if (lstData && lstData.length>0)
				{
					if (!data.last)
					{
						data.last	= {
							project_id: lstData[0].project_id(),
							task_type_id: lstData[0].task_type_id()
						};
					}
//					item.listing.append(lstData);
					newTSDItem.listing.append(lstData);
				}

				// If viewing other user timesheet not need to render new timesheet default.
				// They can add by click new.
				if ((Otime.UID == _this.appModel.sel_user() || Otime.isM) && !item)
				{
					if(data.last)
					{
						_addNewItem(newTSDItem, false, {
							project_id: Number(data.last.project_id),
							task_type_id: Number(data.last.task_type_id),
							atl: assigned_tasks.length
						});
					}
					else
					{
						_addNewItem(newTSDItem, false);	
					}
				}

				if (typeof context.after_callback == "function")
				{
					context.after_callback();
				}
			};

			self.addNew	= _addNewItem;

			var last_date	= null;
			self.load_more	= function(){
				last_date	= last_date || (self.items()[self.items().length-1] ? new Date(self.items()[self.items().length-1].date()) : new Date());
				last_date.addDays(-1);
				
				var postData	= {date: new Date(last_date).format(Otime.sdf)};
				if (!Otime.isM)
				{
					postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
				}

				Otime.app.loadData(new Otime.ContextModel('listing', postData, function(clbk){
					self.load({
						date: new Date(clbk.data.date)
					}, clbk);
				}));
			};
		};

		var assignIsEditable	= function(val){
			var _editable	= !val.invoice_id;

			// if member then check approval required.
			// if approval is required then check the status.
			// if status is Submitted or Approved don't allow to edit that entry.
			if (val._info.user_role() == 'M')
			{
				if ((Otime.isAR && val.status().toUpperCase() == "S") || (val.status().toUpperCase() == "A" && !!(val._info.approved_by()-0)))
				{
					_editable	= false;
				}
			}

//			editable	= editable && !!(_this.projects[val.project_id()].is_active-0);
			// if project is not active not allow to edit.
			if (_this.appModel.act_pro().length)
			{
				_editable = (val.project_id() && $.inArray(val.project_id(), _this.appModel.act_pro()) < 0) ? false : _editable;
			}

//			if (val._info.isFuture && val._info.isFuture())
			// Don't use '&&' operator because else part not apply here.
			if (typeof val._info.isFuture === "function")
			{
				if (val._info.isFuture())
				{
					_editable = false;
				}
			}
			else if(val._info.isFuture)
			{
				_editable = false;
			}

			val._info.is_editable(_editable);

			return _editable;
		};

		_this.TimeSheetDayModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self.today	= Otime.Date();

			self.date	= Otime.o(new Date(data.date).format(Otime.jdf) || self.today.format(Otime.jdf));

			self.listing	= Otime.a([]);
			self.hours		= Otime.o("");

			self.is_running	= Otime.o(false);
			self.running_hours	= Otime.o("");

			var dt	= new Date(self.date());
			self.is_today	= Otime.o(dt.isToday(Otime.timeZoneValue));
			self.is_leave	= Otime.o(dt.isLeave());
			self.is_show	= Otime.o();
			self.isApprove	= Otime.o(false);

			self.is_editable	= Otime.o(true);

			self.showTask	= function(item, elem){
				if (_this.appModel.isRightPane())
				{
					var frm	= _this.appModel.task_detail().selectedItem();
					if (frm.task_id() == item.project_task_id())
					{
						_this.appModel.task_detail().swapPane();
						return false;
					}
				}

				Otime.MyTasks.showTask(item.project_task_id(), item.project_id(), _this.appModel);
			};

			var applyHeaderTimer	= function(resp){
				var prog	= Otime.Menu.progress();
				if (prog)
				{
					prog.hours(resp.hours);
					prog.time_sheet_id(resp.time_sheet_id);
					resp.entry_date && prog.entry_date(Otime.stoj(resp.entry_date).format(Otime.jdf));
				}
			};

			self.stop	= function(item, elem, cont){
				if (Otime.app.running_process() != null)
				{
					item = item || Otime.app.running_process();

					_this.ClearInterval();
					var stopClbk	= function(cont){
						if (cont.response)
						{
							
							if (item.entry_date() != new Date().format(Otime.jdf))
							{
								applyHeaderTimer(cont.response);
								parent.refreshList();
								return;
							}

							var tmp_delete	= [];
							$.each(item.details(), function(key, val){
								if (!val.time_sheet_detail_id())
								{
									tmp_delete.push(val);
									return true;
								}

								if (val.is_progress() == true && val.time_sheet_detail_id() == cont.response.detail_ids)
								{
									val.is_progress(false);
									val.to_time(Otime.RemoveSeconds(cont.response.time));
								}
								else if (cont.response.deleted_ids)
								{
									if (val.time_sheet_detail_id() == cont.response.deleted_ids[0])
									{
										tmp_delete.push(val);
									}
								}
							});

							if (tmp_delete.length > 0)
							{
								$.each(tmp_delete, function(key, val){
									item.details.remove(val);
								});
							}
							self.is_running(false);
							item._info.is_running(false);
							Otime.app.running_process(null);
							applyHeaderTimer(cont.response);
						}
					};

					if (cont)
					{
						stopClbk(cont);
					}
					else
					{
						Otime.app.loadData(new Otime.ContextModel({
							url: 'stop',
							global: false
						}, {
							time_sheet_id: item.time_sheet_id()
						}, stopClbk));
					}
				}
			};

			var ifSaveStart	= false;
			self.saveStart	= function(item){
				if (!item._info.is_active())
				{
					return false;
				}
				ifSaveStart	= true;

//				if (item.time_sheet_id() && new Date(item.entry_date()).isToday())
//					ifSaveStart	= false;

				self.start(item);
			};

			self.continueTask	= function(item){
				if (!item._info.is_active())
				{
					return false;
				}
				ifSaveStart	= true;

				if (item.time_sheet_id() && new Date(item.entry_date()).isToday() && !item.invoice_id)
				{
					ifSaveStart	= false;
				}

				// due to ko.toJSON raise cyclic error while saving.
				item.addHoursDetail();

				self.start(item);
			};

			self.start	= function(item){
				if (!item._info.is_active())
				{
					return false;
				}

				item._info.hours_disp && item._info.hours_disp("");

				if (item.time_sheet_id() == 0 || ifSaveStart)
				{
					ifSaveStart	= false;
					ko.editable(item);
					item.beginEdit();
					self.save(item, self.start);
					return true;
				}

				Otime.app.loadData(new Otime.ContextModel({
					url: 'start',
					global: false
				}, {
					time_sheet_id: item.time_sheet_id()
				}, function(cont){
					if (cont.response)
					{
						_this.curTime	= cont.response.cur_time;
						Otime.Menu.curTime	= cont.response.cur_time;

						var startHeaderTimer	= function(){
							Otime.Menu.activeTask	= {
								 time_sheet_id: cont.response.time_sheet_id,
								 activity_name: item.activity_name(),
								 project_name: item._info.project_name(),
								 is_progress: true,
								 from_time: cont.response.time,
								 hours:	item.hours()
							};
							Otime.Menu.initProgress();
						};

						if (Otime.app.running_process() != null)
						{
							var runItem	= Otime.app.running_process();
							_this.ClearInterval();

							if (runItem.entry_date() != new Date().format(Otime.jdf))
							{
								parent.refreshList();
								startHeaderTimer();
								return true;
							}
							else if(runItem && runItem.details)
							{
								var tmp_delete = [];
								$.each(runItem.details(), function(key, val){
									if (val.is_progress() == true)
									{
										val.is_progress(false);
										val.to_time(Otime.RemoveSeconds(cont.response.time)); 
										if (val.to_time() == val.from_time()) {
											tmp_delete.push(val);						
										}
									}
								});
								if (tmp_delete.length > 0)
								{
									$.each(tmp_delete, function(key, val){
										runItem.details.remove(val);
									});
								}
								runItem._info.is_running(false);
							}
						}

						var ts_num = item._info.task_number();
						if (!new Date(item.entry_date()).isToday(Otime.timeZoneValue) || !!(item.invoice_id-0))
						{
							ts_num = item._info.task_number();
							item	= new _this.TimeSheetDetailModel({
								time_sheet_id: cont.response.time_sheet_id,
								project_id: item.project_id(),
								task_type_id: item.task_type_id(),
								project_task_id: item.project_task_id(),
								project_name: item._info.project_name(),
								task_type_name: item._info.task_type_name(),
								activity_name: item.activity_name(),
								hours: 0,
								estimatedHoursDisp: item.estimatedHoursDisp(),
								estimated_hours: item.estimated_hours(),
								entry_date: Otime.Date().format(Otime.jdf)
							}, self);
							var pj	= Otime.TimeSheet.projects[item.project_id()];
							pj && pj.bg_color && item._info.bg_color(pj.bg_color);
							item._info.is_new(false);
							_this.appModel.day_view().items()[0].listing.splice(1,0,item);
						}

						item.details.push(new _this.HoursDetailModel({
							time_sheet_detail_id: cont.response.detail_ids,
							from_time: Otime.RemoveSeconds(cont.response.time),
							is_progress: true
						}, item));

						item._info.is_running(true);
						item._info.task_number(ts_num);
						item.stop	= self.stop;
						Otime.app.running_process(item);

						self.is_running(true);
						_this.SetInterval(cont.response.time.toString(), item, (item.hours()*60*60), _this.timerTmpl.day, self);
						startHeaderTimer();
					}
				}));
			};

			self.edit	= _this.SetEditable;

			self.remove	= function(item){
				if (item.time_sheet_id() > 0 && confirm(_this.language["CONFIRM_DELETE"]) == true)
				{
					Otime.app.postData(new Otime.ContextModel({
						url: "delete/" + item.time_sheet_id(),
						global: false,
						callback: function(cont){
							self.listing.remove(item);
						}
					}));
				}
			};

			self.cancel	= _this.TimeSheetCancel;

			self.submit	= function(item){
				Otime.app.postData(new Otime.ContextModel({
					url: "submit",
					global: false,
					data: {
						entry_date: new Date(self.date()).format(Otime.sdf)
					},
					callback: function(cont){
						if (cont.response && cont.response[1])
						{
							Otime.success_message(cont.response[1], $("#alert_message"));
						}
						$.each(self.listing(), function(key, val){
							val.status(val._info.is_new() != true ? "S" : "");
						});
					}
				}));
			};

			self.save	= function(item, clbk){
				item	= item || _this.selectedItem;

				if (!item || !item._info.is_active())
				{
					return false;
				}

				/*if (self.hours() > 24)
				{
					alert("Total hours should be less than 24 hours.");
					return false;
				}
/*				if (!self.is_editable())
				{
					return false;
				}
*/
				var ts_id	= item.time_sheet_id();
				var is_invoiced	= !!(item.invoice_id-0);

				_this.TimeSheetSave(item, function(){
					if (self.is_today() && (ts_id <= 0 || is_invoiced) && _this.appModel.sel_user()==Otime.UID)
					{
						parent.addNew(self, false);
					}

					typeof clbk == "function" && clbk(item);
				},function(response, context) {
//					if (context.response[2] && context.response[2]['task_type_invalid']) {
//						self.edit(item);
//					}
				});

				if(item)
					self.is_show(true);
			};

			self.compute_days	= Otime.c(function(){
				var dt	= new Date(self.date());
				var editable	= true;

				if (self.listing().length > 0)
				{
					/*
					var tot = 0;
					var isApproveNeed	= false;
					$.each(self.listing(), function(key, val){
						tot += parseFloat(val.hours());
						if (val.time_sheet_id())
							isApproveNeed	=  (isApproveNeed || val.status()=="");
						editable = val._info.user_role()!='M';
						editable	= editable ? editable : (($.trim(val.status()).toUpperCase()).match("[A|S]") == null);

						self.listing()[key]._info.is_editable(editable);
					});

					self.isApprove(isApproveNeed);

					editable	= editable || !_this.isAR;
					self.hours(tot.toFixed(2));
					*/

					var tot = 0;
					var isApproveNeed	= false;
					$.each(self.listing(), function(key, val){
						tot	+= parseFloat(val.hours()-0);

						if (val.time_sheet_id()-0)
							isApproveNeed	=  (isApproveNeed || val.status()=="");

						editable = assignIsEditable(val) && editable;
					});
					self.isApprove(isApproveNeed);

					editable	= editable || !Otime.isAR;
					self.hours(tot.toFixed(2));
				}
				else
				{
					self.isApprove(false);
					self.hours("0.00");
				}

				var d2	= dt.format(Otime.jdf);
				if (self.days != null && self.days().length > 0)
				{
					$.each(self.days(), function(key, val){
						val.is_current(val.date().format(Otime.jdf) == d2);
					});
				}

				self.is_editable((Boolean(Otime.AEODTS) || (dt.format(Otime.jdf) == Otime.Date().format(Otime.jdf))) && editable);
			});
		};

		_this.selectedItem	= null;

		_this.SetEditable	= function(item){
			if (!item || (item._info.is_active && !item._info.is_active()))
			{
				return false;
			}

			_this.selectedItem	= item;

			if (item.hours)
				item.actual_hours	= item.hours();

			$("#entry-details #message, #alert_message").html("");
			if (Otime.app.is_edit_mode() == false)
			{
				item.is_fresh(true);
				item._info.is_edit_mode(true);
				ko.editable(item);
				item.beginEdit();
				item.addHoursDetail();
				Otime.app.is_edit_mode(true);
			}
		};

		_this.PrepareData	= function(item){
			var totHrs	= 0;

			var task_id	= (ko.utils.unwrapObservable(item.project_task_id)+"").split("-")[0]-0;
			/*if (task_id <= 0 && $.trim(item.activity_name()).trim() == "")
			{
				alert("Please select any task or type task name.");
				item.activity_name("");
				return false;
			}*/

			var rem	= [];
			$.each(item.details(), function(key, val){
				if (!val.time_sheet_detail_id() && (val.from_time() == "" || val.to_time() == ""))
				{
					rem.push(val);
				}

				if (val._destroy)
				{
					return true;
				}
				totHrs	+= (val.hours()-0);
			});

			for (var i=0, iLen=rem.length; i<iLen; i++)
			{
				item.details.remove(rem[i]);
			}

			// update selected user id
			item.user_id	= Otime.UID;
			if (!Otime.isM && _this.appModel)
			{
				item.user_id	= (_this.appModel.sel_user()!=Otime.UID)?_this.appModel.sel_user():item.user_id;
			}

			var copy	= JSON.parse(ko.toJSON(item));

			delete copy._info;

			copy.project_task_id	= task_id;

			copy.direct_entry		= copy.direct_entry-0;
			copy.hours	= (copy.direct_entry + totHrs).toFixed(2)-0;
//			copy.hours	= copy.hours-0 || totHrs;

			copy.is_billable = copy.is_billable ? 1 : 0;

			copy.deleted_details	= [];
			var details	= copy.details.slice();
			copy.details	= [];
			$.each(details, function(key, val){
				if (val._destroy == true)
				{
					copy.deleted_details.push(val.time_sheet_detail_id);
					//delete copy.details[key];
				}
				else if(val.from_time && val.to_time)
				{
					copy.details.push(val);
				}
			});

			return copy;
		};

		_this.TimeSheetSave	= function(item, callback, onError){
			item	= item || _this.selectedItem;

			var data	= _this.PrepareData(item);
			if (!data)
			{
				return false;
			}

// console.log("Save --->", data, data.project_task_id);

			Otime.app.postData(new Otime.ContextModel({
				url: Otime.siteUrl + "/timesheet/save",
//				global: false,
				onError: onError || null,
				data: data,
				callback: function(cont){
					var response	= cont.response[0];

					if(response)
					{
						if (item.time_sheet_id() <= 0)
						{
							item.time_sheet_id(response.time_sheet_id);
						}

						var deleteItems	= [];
						$.each(item.details(), function(key, val){
							if (val.to_time() && val.from_time() && !val.time_sheet_detail_id())
							{
								val.time_sheet_detail_id(response.detail_ids[key]);
							}
							else if(!val.time_sheet_detail_id())
							{
								deleteItems.push(val);
							}

							if (val._destroy && response.deleted_ids && response.deleted_ids.indexOf(val.time_sheet_detail_id()+"") >= 0)
							{
								deleteItems.push(val);
							}
						});

						if (deleteItems.length > 0)
						{
							$.each(deleteItems, function(key, val){
								item.details.remove(val);
							});
							deleteItems	= null;
						}
//						if (response.detail_ids && response.detail_ids.length > 0)
//						{
//							for (var i=0, len=response.detail_ids.length; i<len; i++)
//							{
//								item.details()[i].time_sheet_detail_id(response.detail_ids[i]);
//							}
//						}

						if (data.details.length && response.detail_ids && response.detail_ids.length != data.details.length)
						{
							return false;
						}

						item.actual_hours	= item.hours();
						item.commit && item.commit();

						if (item._info)
						{
							item._info.bg_color && item._info.bg_color(_this.projects[item.project_id()].bg_color || item._info.bg_color());
							item._info.is_new && item._info.is_new(false);
							item._info.is_edit_mode && item._info.is_edit_mode(false);
						}

						Otime.app.is_edit_mode && Otime.app.is_edit_mode(false);

						callback && typeof callback == "function" && callback(response, cont, data);
						if (_this.appModel && _this.appModel.week_view && _this.appModel.week_view())
						{
							_this.UpdateTotalTimes(item.entry_date());
						}
					}

					_this.selectedItem	= null;
				}
			}), true);
		};

		_this.UpdateTotalTimes	= function(entry_date){
			var dy	= new Date(entry_date);
			dy.addDays(Otime.Days.prevDaysCnt(dy));
			var tm	= new Date(dy);
			var url	= "get_hours/" + tm.format(Otime.sdf) + "/";
			tm.addDays(6);
			url	+= tm.format(Otime.sdf);

			var postData	= {};
			if (!Otime.isM)
			{
				postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
			}

			Otime.app.loadData(new Otime.ContextModel(url, postData, function(cont){
				if (cont.response)
				{
					$.each(_this.appModel.week_view().days(), function(key, val){
						if (cont.response[val.date().format(Otime.sdf)])
						{
							val.hours(Number(cont.response[val.date().format(Otime.sdf)].day_total).toFixed(2));
						}
					});
				}
			}));
		};

		_this.TimeSheetCancel	= function(item, callback){
			item	= item || _this.selectedItem;
			if (!item)
			{
				console.log("item not found.");
				return false;
			}

			$("#entry-details #message, #alert_message").html("");

			if (item.time_sheet_id() <= 0)
			{
				item._info.total_hours	= 0;
				item.hours(0);
				item.direct_entry(0);
				item.details([]);
				item.addHoursDetail();
			}
			else
			{
				if (item.details().length > 0)
				{
					$.each(item.details(), function(key, val){
						if (val._destroy)
						{
							delete val._destroy;
						}
					});
				}
				item.rollback && typeof item.rollback == "function" && item.rollback();
			}

//			if (item.time_sheet_id() <= 0 && !Otime.isM && Otime.UID != _this.appModel.sel_user())
//			{
//				return true;
//			}
//			if (item.time_sheet_id() > 0 || Otime.isM || !_this.appModel || Otime.UID == _this.appModel.sel_user())
//			{
				item._info && item._info.is_edit_mode && item._info.is_edit_mode(false);
				item.is_fresh && item.is_fresh(Otime.UID == _this.appModel.sel_user()?false:null);
				Otime.app.is_edit_mode && Otime.app.is_edit_mode(false);
//			}

			typeof callback === "function" && callback();

			_this.selectedItem	= null;

			return false;
		};

		_this.DayModel	= function(data){
			var self	= this;

			data	= data || {};

			self.date		= Otime.o(data.date || new Date());

			self.day_name	= Otime.o("");

			self.day_value	= Otime.o("");

			self.hours		= Otime.o(data.hours || "");
			self.running_hours	= Otime.o();
			self.is_ts_running	= Otime.o(false);

			self.is_current	= Otime.o(false);

			self.is_leave	= Otime.o(false);

			var ts = '';

			self.compute	= Otime.c(function() {
				self.day_name(self.date().format("ddd"));
				self.day_value(self.date().format("dd"));

				self.is_leave(new Date(self.date()).isLeave());
			});
		};

		_this.CheckHours	= function(hrs){
//			var expr	= /^(\d+)(\:|\.)(\d+)|^(\d+)|^(\:|\.)(\d+)/;
			var expr	= /^(^-?\d+)(\:|\.)(\d+)|^(^-?\d+)|^(\:|\.)(\d+)/;

			hrs	= (hrs + "").match(expr);

			if (!hrs)
			{
				return "";
			}

			var s_hr	= hrs[1] || hrs[4] || 0,
				s_mi	= hrs[3] || hrs[6] || 0,
				sep	= hrs[2] || hrs[5];
			var hr	= Number(s_hr),
				mi	= Number("0."+s_mi);

			/*if (hr >= 24)
			{
				s_hr = "24";
				s_mi = "0";
			}*/

			if (sep == ":")
			{
				s_mi	= (mi > 0.59) ? "0" : (mi/0.6).toFixed(2);
				s_mi	= s_mi.replace("0.", "");
			}

			s_mi	= (mi > 100) ? 0 : s_mi;

			return Number(s_hr + "." + s_mi);
		};

		_this.TimeSheetDetailModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self._info	= {};

			self.time_sheet_id	= Otime.o(data.time_sheet_id || 0);
			self.project_id		= Otime.o(data.project_id || 0);
			self.task_type_id	= Otime.o(data.task_type_id || 0);
			self.project_task_id	= Otime.o(data.project_task_id || 0);

			self.is_billable	= Otime.o(!!(data.is_billable-0));

			self._info.hrsFocus	= false;
			self.updateHrs	= function(){
				self._info.hrsFocus	= true;
			};

			data.hours	= ((data.hours || 0)-0).toFixed(2)-0;
			self.hours	= Otime.o(data.hours || "");
			data.estimated_hours	= ((data.estimated_hours || 0)-0).toFixed(2)-0;
			self.estimated_hours	= Otime.o(data.estimated_hours || "");

			self.total_hours	= Otime.o(data.hours-0);
			self.entry_total	= Otime.o(0);
			self.direct_entry	= Otime.o(data.direct_entry-0);

//			data.entry_date	= (data.entry_date) ? data.entry_date.replace(/-/g, "/") : (new Date().format(Otime.jdf));
			self.entry_date	= Otime.o(new Date(data.entry_date).format(Otime.jdf));

			self.notes			= Otime.o(data.notes || "");
			self.status		= Otime.o(data.approval_status || "");
			self.invoice_id	= data.invoice_id-0 || 0;
			self.is_fresh	= Otime.o(Boolean(data.is_fresh));

			self.is_locked	= Otime.o(false);
			var CheckLock	= function(){
				self.is_locked((self.invoice_id || (!Otime.isA && self.status())));
			};
			CheckLock();
			self.status.subscribe(CheckLock);

			self.stop	= null;

			self._info.task_types		= Otime.a([]);
			self._info.project_name		= Otime.o("");
			self._info.task_type_name	= Otime.o(data.task_type_name || "");
			self.activity_name			= Otime.o(data.activity_name || "");
			self._info.user_role		= Otime.o(data.user_role || "");
			self._info.is_editable		= Otime.o(true);
			self._info.bg_color			= Otime.o(data.bg_color || "#EEEEEE");
			self._info.task_number		= Otime.o(data.task_number || "");
			self._info.task_priority	= Otime.o(data.task_priority || "");
			self._info.approved_by		= Otime.o(data.approved_by || 0);

			self._info.total_hours	= 0;

			self._info.isFuture	= new Date(self.entry_date()).isFuture();
			self._info.isPast	= new Date(self.entry_date()).isPast();
			self._info.isToday	= new Date(self.entry_date()).isToday();

			self._info.is_new		= Otime.o(Boolean(Number(data.is_new)));
			self._info.is_running	= Otime.o(Boolean(Number(data.is_progress)));
			self._info.is_edit_mode	= Otime.o(Boolean(Number(data.is_edit_mode)));
			self._info.is_edit_mode.subscribe(function(){
				Otime.app.is_edit_mode(self._info.is_edit_mode());
			});
			self._info.showBtn	= Otime.o(true);
			self._info.enStart	= Otime.o(true);
			self._info.is_cmt	= Otime.o(false);
			self._info.hours_disp	= Otime.o("");
			self._info.is_active	= Otime.o(false);

			self._info.is_extra	= Otime.o(!!(Otime.Storage.get("ts_popup_extra", Otime.tsReq)-0));
			self.swap_extra	= function(){
				self._info.is_extra(!self._info.is_extra());
				Otime.Storage.set("ts_popup_extra", self._info.is_extra() ? 1 : 0);
			};

			self.details	= Otime.a([]);
			var detailsSubscribe	= function(){
				var entry_tot	= 0;
				if (self.details().length > 0)
				{
					$.each(self.details(), function(key, val){
						if (val.is_progress() == false && (val._destroy==undefined || val._destroy==false))
						{
							entry_tot += Number(val.hours());
						}
					});
					entry_tot	= Number(entry_tot.toFixed(2));
				}
				if (self.entry_total() != entry_tot)
				{
					// self.direct_entry(0);
					self.entry_total(entry_tot);
					self.hours(self.direct_entry() + entry_tot);
				}
			};
//			self.details.subscribe(detailsSubscribe);
			self.detailHrsSubscribe	= detailsSubscribe;

			if (data.details != undefined && Object.keys(data.details).length > 0 && data.details.otkeys != undefined && data.details.otvalues != undefined)
			{
				var details	= [],
					tmpItem	= null,
					from_time	= null,
					tot	= 0;

				data.details	= data.details.otvalues.setKeys(data.details.otkeys, function(val){
					if(val.hours)
					{
						tot	= (Number(tot) + Number(val.hours)).toFixed(2);
					}
					if (Boolean(Number(val.is_progress)))
					{
						from_time	= val.from_time;
						val.from_time	= Otime.RemoveSeconds(val.from_time);
					}
					details.push(new _this.HoursDetailModel(val, self));
				});
				tot	= Number(tot).toFixed(2);
				self.details(details);
				self.entry_total(Number(tot));

				if (from_time)
				{
					var tod	= Otime.Date();
					var diff_hrs = 0;

					if (typeof self.entry_date === "function" && tod.format(Otime.jdf) != new Date(self.entry_date()).format(Otime.jdf))
					{
//						diff_hrs	= Math.round((new Date(tod.format("YYYY/MM/DD")).getTime() - new Date(self.entry_date() + " " + from_time).getTime())/36E5);
//						diff_hrs	= Math.round((tod.getTime() - new Date(self.entry_date() + " " + from_time).getTime())/36E5);
//						diff_hrs	= Math.round((new Date(tod.format("YYYY/MM/DD")  + " " + from_time).getTime() - new Date(self.entry_date() + " " + from_time).getTime())/36E5);
/*
						var todyMorning	= new Date(tod.format(Otime.jdf)).getTime();
						diff_hrs	= Math.round((todyMorning - new Date(self.entry_date() + " " + from_time).getTime())/36E5);
						var todFrmTime	= new Date(tod.format(Otime.jdf + " " + from_time));
						var todayDiff	= Math.round((((tod.getTime() > todFrmTime.getTime()) ? todFrmTime : tod) - todyMorning)/36E5);

						var todayDiff	= (todFrmTime.getTime() - todyMorning) / (1000*60*60);
						self.hours((self.hours()-0) + diff_hrs + todayDiff);
*/
						self.hours(self.hours()-0);
					}
					if (parent && parent.running_hours)
					{
						parent.is_running && parent.is_running(true);
						_this.SetInterval(from_time.toString(), self, (Number(self.hours())*60*60), _this.timerTmpl.day, parent);
					}
					else
					{
						_this.SetInterval(from_time.toString(), self, (Number(self.hours())*60*60), _this.timerTmpl.day);
					}
				}
			}
			self.hours(data.hours);
			data.direct_entry	= Number((self.hours() - self.entry_total()).toFixed(2));
			self.direct_entry(data.direct_entry);

			self.showCmt	= function(type){
				type	= "is_" + type.toLowerCase();
				return function(){
					self._info[type] && self._info[type](!self._info[type]());
				};
			};

			if(_this.projects != null)
			{
				var pj	= _this.projects[self.project_id()];
				if (!pj)
				{
					pj	= _this.projects[Object.keys(_this.projects)[0]];
				}
				self._info.is_active(!!(pj.is_active-0));
				self.project_id() || self.project_id(Number(pj.project_id));
				self.project_id(self.project_id() || data.project_id || Number(pj.project_id));
				self._info.project_name((pj.project_code ? pj.project_code : '') + pj.project_name);

				self.project_id.subscribe(function(newVal){
					self.task_type_id(0);
					self.project_task_id(0);
	
					if (!newVal)
					{
						return false;
					}
					pj	= _this.projects[newVal];
					self._info.project_name((pj.project_code ? pj.project_code : '') + pj.project_name);
					_this.Tasks.isNullResult	= false;
					if (newVal)
					{
						var ttyps	= _this.getTTY(newVal);
						if (ttyps && ttyps.length > 0)
						{
							self._info.task_types(ttyps);
							self.task_type_id(self.task_type_id() || data.task_type_id || Number(ttyps[0].task_type_id));		
						}
					}
				});

				var ttypes;
				if (data.task_types)
				{
					ttypes	= Object.values(data.task_types);
				}
				else
				{
					ttypes	= _this.getTTY(self.project_id());
				}

				if (ttypes)
					self._info.task_types(ttypes);

				ttypes	= data.task_types || _this.projects[self.project_id()].task_types;
				pj	= ttypes[self.task_type_id()];
				if (pj)
				{
					self.task_type_id() || self.task_type_id(parseInt(pj.task_type_id));
					self._info.task_type_name(pj.name);
				}
				
				//self.is_billable(pj.is_billable-0);
				self.task_type_id.subscribe(function(newVal){
					// self.project_task_id(0);
					_this.Tasks.isNullResult	= false;
					if (!self.project_id() || !newVal)
					{
						return false;
					}
					pj	= _this.projects[self.project_id()].task_types;
					if (pj)
					{
						pj	= pj[self.task_type_id()];
						self._info.task_type_name(pj != undefined ? pj.name : '');

						self.is_billable(!!(pj != undefined ?pj.is_billable-0:0));
					}
				});
			} else {
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
			}

			self.activity_name.subscribe(function(newVal){
//				$.trim(newVal) == ""
				if (!self.activity_name.original_value || newVal != self.activity_name.original_value)
				{
					self.project_task_id(0);
				}
			});

			self.getTasks	= function(request, callback){
				_this.Tasks.get(request, callback, self);
			};

			self.setTasks	= function(event, ui){
				_this.Tasks.set(event, ui, self);
			};

			self.addHoursDetail	= function(){
				if (self.details().length == 0)
				{
					self.details([]);
				}

				var newHrsModel	= new _this.HoursDetailModel({}, self);
				newHrsModel.from_time("");
				newHrsModel.to_time("");
				self.details.push(newHrsModel);
			};

			self.newHrs	= function(index, item, elem){
				if (index != undefined && (index() == $("tr", $(elem.target).closest("tbody")).length-1) && $.trim(item.from_time()) != "")
				{
					self.addHoursDetail();
				}
			};

			self.deleteHrs	= function(item) {
				if (item.time_sheet_detail_id() > 0)
				{
					self.details.destroy(item);
				}
				else
				{
					self.details.remove(item);
				}

				if (self.details().length == 0)
				{
					self.addHoursDetail();
				}
				detailsSubscribe();
			};

			self.hoursDisp	= Otime.o("");
			self.onChange	= function(){
				self.hours(self.hoursDisp());
			};
			self.estimatedHoursDisp	= Otime.o("");
			self.onChangeEst	= function(){
				self.estimated_hours(self.estimatedHoursDisp());
			};

//			var toString	= Otime.formatHrs;
			self.hoursDisp(Otime.formatHrs(self.hours(), true));
			self.estimatedHoursDisp(Otime.formatHrs(self.estimated_hours(), true));

			var tmpHrsFlag	= false;
			self.hours.subscribe(function(newVal){
				if (!tmpHrsFlag)
				{
					tmpHrsFlag	= true;
					self.hours(_this.CheckHours(newVal));
					if (!tmpHrsFlag)
					{
						return true;
					}
				}
				tmpHrsFlag	= false;

				if (self._info.hrsFocus)
				{
					self._info.hrsFocus	= false;
					self.direct_entry(self.hours() - self.entry_total());
				}

				newVal	= Otime.formatHrs(newVal, true);
				self.hoursDisp(newVal);
			});

			self.estimated_hours.subscribe(function(newVal){
				newVal	= Otime.formatHrs(newVal, true);
				self.estimatedHoursDisp(newVal);
			});

//			self.entry_total.subscribe(function(newVal){
//				self.hours(self.direct_entry()+newVal);
//			});

//			self.direct_entry.subscribe(function(newVal){
//				self.hours(self.entry_total()+newVal);
//			});

			self.compute	= Otime.c(function(){
				self._info.showBtn(self._info.is_active() && !self._info.is_running() && ((_this.appModel && Otime.UID == _this.appModel.sel_user()) || Otime.isM || data.is_task_page));

//				self._info.enStart(Otime.app.is_edit_mode()==false && (self.project_task_id()>0 || $.trim(self.activity_name())!=""));
//				self._info.enStart(Otime.app.is_edit_mode()==false || self.project_task_id()>0);
				self._info.enStart(self.project_id()>0);

//				var entry_tot	= 0;
//				if (self.details().length > 0)
//				{
//					$.each(self.details(), function(key, val){
//						if (val.is_progress() == false && (val._destroy==undefined || val._destroy==false))
//						{
//							entry_tot += Number(val.hours());
//						}
//					});
//
//					entry_tot	= Number(entry_tot.toFixed(2));
//				}
//				self.entry_total(entry_tot);
			});
		};
		
		_this.getTTY	= function(newVal){
			newVal	= newVal || 0;

			if (_this.projects==null || !_this.projects[newVal] || !newVal)
			{
				return false;
			}

			var newArr	= [];

			if (_this.projects[newVal].task_types)
			{
				$.each(_this.projects[newVal].task_types, function(key, val){
					newArr.push(val);
				});
			}

			return newArr;
		};

		_this.HoursDetailModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			self.time_sheet_detail_id	= Otime.o(data.time_sheet_detail_id || 0);

			data.from_time	= data.from_time || "00:00 AM";
			data.to_time	= data.to_time || "00:00 AM";

			if (Otime.hourFormat)
			{
				data.from_time	= new Date("2014/01/01 " + data.from_time).format("OO:NN");
				data.to_time	= new Date("2014/01/01 " + data.to_time).format("OO:NN");
			}

			self.from_time		= Otime.o(data.from_time);
			self.to_time		= Otime.o(data.to_time);
			self.is_progress	= Otime.o(Boolean(Number(data.is_progress)));
			self.hours			= Otime.o(data.hours || "");
			self.isValid		= Otime.o(true);

			if (parent && parent.detailHrsSubscribe)
			{
				self.hours.subscribe(function(newVal){
					newVal && parent.detailHrsSubscribe();
				});

				if (self.is_progress())
				{
					var tod	= Otime.Date();
					if (tod.format(Otime.jdf) != parent.entry_date())
					{
						var diff	= (Otime.Date().getTime() - new Date(parent.entry_date() + " " + self.from_time()).getTime()) / (1000*60*60);
						diff	= Math.floor(diff);
						self.hours(diff);
					}
				}
			}

			self.itemBlur	= function(item, elem, field) {
				field	= field || undefined;

				elem	= $(elem.delegateTarget);
				if (elem.is(".fromDt"))
				{
					$("input.toDt", elem.parents("tr.detail")).timeEntry('option', 'minTime', self.from_time());
				}

				if (self.from_time() == "" && self.to_time() == "")
				{
					self.isValid(true);
					return true;
				}

				if (field != undefined)
				{
					return true;
				}

				if ((self.from_time() == "" && self.to_time() != "") || (self.from_time() != "" && self.to_time() == ""))
				{
					self.isValid(false);
					return false;
				}

				var from_time	= new Date("01/01/1991 " + self.from_time()).getTime();
				var to_time		= new Date("01/01/1991 " + self.to_time()).getTime();
				self.isValid((from_time < to_time));
			};

			self.compute	= Otime.c(function() {
				if (self.is_progress() == false)
				{
					self.hours(jhelper.getTimeDiffPercent(self.from_time(), self.to_time()));
				}
			});
		};

		_this.TimeSheetWeekModel	= function(data){
			var self	= this;

			data	= data || {};
			data.listing	= data.listing || "";

			self.today			= Otime.Date();
			self.date			= Otime.o(self.today.format(Otime.jdf));
			self.current_date	= Otime.o(data.current_date || self.date());
			self.listing		= Otime.a([]);
			self.total_hours	= Otime.o(0);
			self.is_allow		= Otime.o(false);	
			self.days			= Otime.a([]);
			self.hours			= Otime.o("");
			self.running_hours	= Otime.o("");
			self.is_ts_running	= Otime.o(false);
			self.isApprove	= Otime.o(false);

			self.showTask	= function(item, elem){
				Otime.MyTasks.showTask(item.project_task_id(), item.project_id(), _this.appModel);
			};

			self.is_options	= Otime.o(false);
			self.showOpt	= function(activity_name){
				if (activity_name != null)
				{
					return function(){
						self.is_options(activity_name() != "");
					};
				}

				return function(){
					self.is_options(true);
				};
			};

//			console.log(self.hours(), self.days().length);

			self.new_item		= Otime.o(null);

			self.nav_date	= Otime.o("");

			self.changeDate	= function(item, elem) {
//				if (item.date().isFuture())
//				{
//					Otime.error_message("Future date not allowed.", $("#alert_message"));
//					return false;
//				}
				_this.appModel.loadDefault({
					entry_date		: item.date().format(Otime.jdf)
				});

				(_this.appModel.swap_view(_this.Views.DAY_VIEW))();
			};

			self.dtchange	= function(item, elem, val){
				var dt	= new Date(self.date());
				elem	= $("#date-picker");
				if (dt != null)
				{
					dt.addDays(Number(val));
					elem.datepicker("update", dt);
					elem.change();
				}
			};

			self.week_change	= function(val){
				return function(item, elem){
					var day	= new Date(self.current_date());
					day.addDays(Number(val + "7"));
					self.date(day.format(Otime.jdf));
					//self.is_options(false);
				};
			};

			self.submit	= function(item){
				var data	= {
					week_view	: true,
					start_date	: self.days()[0].date().format(Otime.sdf),
					end_date	: self.days()[self.days().length-1].date().format(Otime.sdf)
				};

				Otime.app.postData(new Otime.ContextModel({
					url: "submit",
					global: false
				}, data, function(cont){
					if (cont.response && cont.response[1])
					{
						Otime.success_message(cont.response[1], $("#alert_message"));
					}

					for (var i=0,tmpItems=null,lst=item.listing(),iLen=lst.length; i<iLen; i++)
					{
						tmpItems	= lst[i].hours_list_week();
						for (var j=0,jLen=tmpItems.length; j<jLen; j++)
						{
							if (tmpItems[j].time_sheet_id() > 0 && tmpItems[j].status() == "")
							{
								tmpItems[j].status("S");
							}
						}
					}
					self.isApprove(false);
				}));
			};

			self.loadInfo	= function(callback){
				var localCallback	= function(){
					var prjId	= 0,
						ttyId	= 0,
						def		= self.listing()[0];

					if (def)
					{
						prjId	= Number(def.project_id());
						ttyId	= Number(def.task_type_id());
					}

					var newItem	= new _this.WeekListModel({
						start_date: self.days()[0].date(),
						is_new: true,
						project_id: prjId,
						task_type_id: ttyId
					}, null, self.days, self);
					ko.editable(newItem);
					newItem.beginEdit();
					self.new_item(newItem);
				};

				if (self.days().length == 7)
				{
					var week_data	= {
						start_date	: self.days()[0].date(),
						end_date	: self.days()[6].date(),
						listing		: {}
					};

					var postData	= {
						start_date: self.days()[0].date().format(Otime.sdf),
						end_date: self.days()[6].date().format(Otime.sdf)
					};
					if (!Otime.isM)
					{
						postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
					}

					Otime.app.loadData(new Otime.ContextModel('listing/week', postData, function(cont){

						self.listing([]);

						_this.curTime	= cont.response.cur_time;
						Otime.Menu.curTime	= cont.response.cur_time;

						var listingArr	= [],
							activity_names = {};

						// for remove from assigned tasks.
						var existItems	= [];

						if (cont.response && cont.response.items && cont.response.items.otvalues)
						{
							var items	= cont.response.items, objKey	= null;
							var tod	= Otime.Date(), dt=null;
							var oldTimerEntry	= null;

							/***
							 * Preparing array and Making 7days complete data (dummy for non timesheet days,
							 * If timesheet not available for any date then make dummy record for that.)
							 */
							items	= items.otvalues.setKeys(items.otkeys, function(val){
								// objKey	= "item-" + val.project_id + "-" + val.task_type_id + "-" + val.project_task_id + "-" + val.invoice_id+ '-' + val.time_sheet_id;
//								if ((val.project_task_id-0) <= 0)
//								{
//									val.project_task_id	= val.activity_name.hashCode();	// Otime.Random();
//								}

								objKey	= "item-" + val.project_id + "-" + val.task_type_id + "-" + val.project_task_id + "-" + val.invoice_id + '-' + val.activity_name;

								if (!!(val.is_progress-0))
								{
									dt	= Otime.stoj(val.entry_date);
									if (dt.format(Otime.jdf) != tod.format(Otime.jdf))
									{
										oldTimerEntry	= val;
										oldTimerEntry.objKey	= objKey;
									}
								}

								// Will check for avoid duplicate by appending assigned tasks.
								existItems.push(val.project_id + "-" + val.task_type_id + "-" + val.project_task_id);

								activity_names[objKey]	= activity_names[objKey] || val.activity_name;
								// Dummy record creation here for non data dates.
								week_data.listing[objKey]	= week_data.listing[objKey] || {};
								week_data.listing[objKey][val.entry_date] = val;
								week_data.listing[objKey]['bg_color'] = val.bg_color;
								week_data.listing[objKey]['task_number'] = val.task_number;
								week_data.listing[objKey]['task_priority'] = val.task_priority;
							});

							if (oldTimerEntry)
							{
								objKey	= oldTimerEntry.objKey;
//								oldTimerEntry.entry_date
								week_data.listing[objKey][tod.format(Otime.sdf)] = oldTimerEntry;
							}
						}

						var assignedTasks	= cont.response.assigned_tasks;
						if (assignedTasks && assignedTasks.otvalues)
						{
							assignedTasks	= assignedTasks.otvalues.setKeys(assignedTasks.otkeys, function(val){
								objKey	= "item-" + val.project_id + "-" + val.task_type_id + "-" + val.project_task_id + "-" + (val.invoice_id || 0) + '-' + val.activity_name;

								if (existItems.indexOf(val.project_id + "-" + val.task_type_id + "-" + val.project_task_id) >= 0)
								{
									return true;
								}

								activity_names[objKey]	= activity_names[objKey] || val.activity_name;
								// Dummy record creation here for non data dates.
								week_data.listing[objKey]	= week_data.listing[objKey] || {};
								week_data.listing[objKey][val.entry_date] = val;
								week_data.listing[objKey]['bg_color'] = val.bg_color;
								week_data.listing[objKey]['task_number'] = val.task_number;
								week_data.listing[objKey]['task_priority'] = val.task_priority;
							});
						}

						var keys	= Object.keys(week_data.listing) || [],
						key	= null, val = null,
						start_date	= self.days()[0].date().format(Otime.jdf),
						end_date	= self.days()[6].date().format(Otime.jdf);

						for (var i=0, iLen=keys.length; i<iLen; i++)
						{
							key	= keys[i];
							val	= week_data.listing[key];

							// var k = key.match(/item-(\d+)-(\d+)-(\d+)-(\d+)-(\d+)/i);
							var k = key.match(/^item-(\d+)-(\d+)-(\d+)-(\d+)-(\S+)|^item-(\d+)-(\d+)-(\d+)-(\d+)-/i);
							if (!k) continue;
							listingArr.push(new _this.WeekListModel({
								project_id: k[1] || k[6],
								task_type_id: k[2] || k[7],
								project_task_id: k[3] || k[8],
								invoice_id: k[4] || k[9],
	//							time_sheet_id:k[5] || k[10],
								time_sheet_id:k[5] || k[10],
								activity_name: activity_names[key] || "",
								start_date: start_date,
								end_date: end_date,
								list: val,
								bg_color:val.bg_color,
								task_number:val.task_number,
								task_priority:val.task_priority
							}, cont.response.active, self.days, self));
						}

						self.listing(listingArr);

						if(self.listing().length==0){
							self.is_options(true);
						}
						else {
							self.is_options(false);
						}
						callback && callback();
						localCallback();
					}));
				}
			};

			self.date.subscribe(function(newVal){
				self.current_date(newVal);
				var dt	= new Date(self.current_date());
				if (self.days != null && self.days().length > 0)
				{
					if (dt >= self.days()[0].date() && dt <= self.days()[6].date())
					{
						self.loadInfo();
					}
					else
					{
						_this.Render(self);
					}
				}
			});

			self.compute	= Otime.c(function(){
				var tot	= 0,
					isApproveNeed	= false;
				
				$.each(self.listing(), function(key, val){
					isApproveNeed	=  (isApproveNeed || val.isApprove());
					tot += parseFloat(val.total_hours());
				});
				self.hours(tot.toFixed(2));
				self.isApprove(isApproveNeed);

				if (self.days != null && self.days().length == 7)
				{
					var start_date	= self.days()[0].date(), end_date	= self.days()[6].date(), format	= "DD";
					if (start_date.getFullYear() != end_date.getFullYear())
						format	= "DD MMM, YYYY";
					else if (start_date.getMonth() != end_date.getMonth())
						format	= "DD MMM";

					self.nav_date(start_date.format(format) + end_date.format(" - DD MMM, YYYY"));
					end_date = start_date = format = null;

					var dt	= new Date(self.current_date()), d2	= dt.format(Otime.jdf);
					$.each(self.days(), function(key, val){
						val.is_current(val.date().format(Otime.jdf) == d2);
					});
				}
			});
		};

		/***
		 *  Week view listing model.
		 * @param data - data to assign.
		 * @param active - if any timesheet is started, active will hold that details.
		 * @param daysList - reference to table header days list for update hours when edit.
		 * @returns
		 */
		_this.WeekListModel	= function(data, active, daysList, parent){
			var self	= this;

			data		= data || {};
			data.list	= data.list || {};

			self._info	= {};
			self._info.is_ts_running	= Otime.o(false);
			self._info.is_ts_running.subscribe(function(newVal){
				parent.is_ts_running(newVal);
			});
			self._info.running_hours	= Otime.o(0);
			self._info.is_active	= Otime.o();

			self.getTodayHeader	= function(){
				var tmpDay	= null;
				$.each(daysList(), function(key, val){
					if (val.date().isToday())
					{
						tmpDay	= val;
						return false;
					}
				});
				return tmpDay;
			};

			self.getParent	= function(){
				return parent;
			};

			if(_this.projects != null)
			{
				var pj	= _this.projects[data.project_id], ttypes = null;
				if (!pj)
				{
					pj	= _this.projects[Object.keys(_this.projects)[0]];
					data.project_id		= pj.project_id;
					data.project_name	= pj.project_name;
				}
				self._info.is_active(!!(pj.is_active-0));
				ttypes	= pj.task_types[data.task_type_id || Object.keys(pj.task_types)[0]];
				if (ttypes)
				{
					data.task_type_id	= ttypes.task_type_id;
					data.task_type_name	= ttypes.name;
				}
			} else {
				Otime.show_propop('Track Your Time', 'Create your project to track your time');
			}

			self.project_id			= Otime.o(data.project_id || 0).extend({required:"Project required"});
			self._info.project_name	= Otime.o(data.project_name || "");
			self._info.task_number	= Otime.o(data.task_number || "");
			self._info.task_priority= Otime.o(data.task_priority || "");
			self._info.bg_color		= Otime.o(data.bg_color || "#EEEEEE");

			self._info.task_types	= Otime.a([]);
			var ttyps	= _this.getTTY(self.project_id());
			if (ttyps)
			{
				self._info.task_types(ttyps);
			}

			self.task_type_id		= Otime.o(Number(data.task_type_id) || 0).extend({required:"Task type required"});
			self.project_task_id	= Otime.o(data.project_task_id || 0);

			self._info.task_type_name	= Otime.o(data.task_type_name || "");
			self.activity_name			= Otime.o(data.activity_name || "");
			self.is_billable		= Otime.o(data.is_billable>0?true:false);

			self.total_hours		= Otime.o(0);
			self.hours_list_week	= Otime.a([]);
			self.is_new				= data.is_new || false;
			self.invoice_id			= data.invoice_id || 0;
			self.time_sheet_id		= data.time_sheet_id;

			self.project_id.subscribe(function(newVal){
				self.task_type_id(Number(data.task_type_id) || 0);
				self.project_task_id(0);
				if (newVal)
				{
					var ttyps	= _this.getTTY(newVal);
					if (ttyps)
						self._info.task_types(ttyps);
				}
			});
			
			self.task_type_id.subscribe(function(newVal){
//				self.project_task_id(0);
				if (!self.project_id() || !newVal)
				{
					return false;
				}

				pj	= _this.projects[self.project_id()].task_types;
				pj	= pj[self.task_type_id()];
				self._info.task_type_name(pj != undefined ? pj.name : '');
				self.is_billable(!!(pj != undefined ?pj.is_billable-0:0));
			});

			if (data.hours_list_week != undefined && data.hours_list_week.length == 7)
			{
				var newArr	= [];
				$.each(data.hours_list_week, function(key, val){
					newArr.push(new _this.HoursListModel(val, active, self));
				});
				self.hours_list_week(newArr);
			}
			else if(data.start_date)
			{
				var newArr		= [],
					isActive	= false;

				var listItem	= null;

				for(var i=0; i<7; i++)
				{
					var dt	= new Date(data.start_date);
					dt.addDays(i);
					dt	= dt.format(Otime.sdf);

					listItem	= data.list[dt] || {
						entry_date: dt,
						hours:0,
						time_sheet_id:0
					};

					listItem.entry_date	= listItem.entry_date || dt;
					listItem.actual_date	= dt;

					isActive	= false;
//					if (active && dt == active.entry_date && active.time_sheet_id == data.list[dt].time_sheet_id)
					if (active && active.time_sheet_id == listItem.time_sheet_id)
					{
						listItem.is_progress	= true;
						listItem.from_time		= active.from_time;
						isActive	= true;
						self._info.is_ts_running(true);
						_this.appModel.active_parent(self);
					}

					newArr.push(new _this.HoursListModel(listItem, isActive, self));
				}
				self.hours_list_week(newArr);
			}

			self.getTasks	= function(request, callback){
				_this.Tasks.get(request, callback, self);
			};

			self.setTasks	= function(event, ui){
				_this.Tasks.set(event, ui, self);
			};

			// for change "Save" button into "Apply" button & hide the cancel button.
			self.editNew	= function(item, elem, postTS){
				self.edit(item, elem, postTS, true);
			};

			self.edit	= function(item, elem, postTS, is_from_new){
				if (!self._info.is_active())
				{
					return false;
				}

				if ($(elem.target).is(".notes"))
				{
					_this.appModel.showNotes(item, $(elem.target).parents("td"));
					return true;
				}

				// for change "Save" button into "Apply" button & hide the cancel button.
				item._info.is_from_new	= is_from_new || false;

				if ($(elem.target).hasClass("start"))
				{
					self.start(item, elem);
					return true;
				}

				if (!item._info.is_editable())
				{
					return false;
				}

				if (item._info.is_ts_running())
				{
					alert("Timesheet not editable.");
					return false;
				}

				if(item.count() > 1)
				{
					_this.appModel.loadDefault({
						entry_date		: item.entry_date(),
						time_sheet_id	: item.max()
					});

					(_this.appModel.swap_view(_this.Views.DAY_VIEW))();
					return true;
				}

				postTS	= postTS || false;
				var data	= {
					entry_date		: item.entry_date(),
					time_sheet_id	: item.time_sheet_id(),
					project_id		: self.project_id(),
					task_type_id	: self.task_type_id(),
					project_task_id	: self.project_task_id(),
					notes			: item.notes(),
					hours			: item.hours(),
					details			: null
				};

				if (Otime.tsReq || postTS)
				{
					if (item.time_sheet_id() > 0)
					{
						Otime.app.loadData(new Otime.ContextModel("details/" + item.time_sheet_id(), null, function(cont){
							data.details	= cont.response;
							self.loadEntryDetails(data, item, cont);
						}));
						return true;
					}
					else
					{
						data.details	= item.details() || null;
						self.loadEntryDetails(data, item);
						return true;
					}
				}

				item.actual_hours	= item.hours();

				ko.editable(item);
				item.is_edit_mode(true);
				item.beginEdit();
				$("#hours").select();
				return true;
			};

			self.loadEntryDetails	= function(data, item, cont){
				data.activity_name	= self.activity_name();
				var newItem	= new _this.TimeSheetDetailModel(data);
				newItem.cancelItem = function(){
					_this.TimeSheetCancel(newItem, function(){
						$("#entry-details").modal('hide');
					});
				};

				if (item && item._info.is_from_new && item.details)
				{
					var dt	= [];
					$.each(item.details(), function(key, val){
						dt.push(new _this.HoursDetailModel(val, self));
					});
					newItem.details(dt);
				}

				// for change "Save" button into "Apply" button & hide the cancel button.
				newItem._info.is_from_new	= item._info.is_from_new;

				newItem.save	= function(){
					if (self.is_new == false)
					{
						_this.TimeSheetSave(newItem, function(response){
							Otime.app.is_edit_mode(false);
							item.time_sheet_id(newItem.time_sheet_id());
							item.hours(newItem.hours());
							$("#entry-details").modal('hide');
						}, function(msg){
							Otime.error_message(msg, $("#entry-details #message"));
							return false;
						});
					}
					else
					{
						var tmpData	= JSON.parse(ko.toJSON({
							entry_date: newItem.entry_date,
							details: newItem.details
						}));
						var postData = {
							entry_date: tmpData.entry_date,
							details:[]
						};

						postData.user_id	= Otime.UID;
						if (!Otime.isM && _this.appModel)
						{
							postData.user_id	= (_this.appModel.sel_user()!=Otime.UID)?_this.appModel.sel_user():postData.user_id;
						}

						for (var i=0; i<tmpData.details.length; i++)
						{
							if (tmpData.details[i].from_time && tmpData.details[i].to_time)
							{
								postData.details.push(tmpData.details[i]);
							}
						}

						Otime.app.postData(new Otime.ContextModel({
							url: "valid",
							data: postData,
							callback: function(){
								newItem.commit();
								newItem._info.is_new(false);
								newItem._info.is_edit_mode(false);
								Otime.app.is_edit_mode(false);

								item.details([]);
								$.each(newItem.details(), function(key, val){
									if (val.from_time() && val.to_time())
									{
										item.details.push({
											from_time: val.from_time(),
											to_time: val.to_time(),
											time_sheet_detail_id:0,
											hours:val.hours()
										});
									}
								});

								item.hours(newItem.hours());
								$("#entry-details").modal('hide');
							},
							onError: function(msg){
								Otime.error_message(msg, $("#entry-details #message"));
								return false;
							}
						}));
					}
				};

				_this.SetEditable(newItem);
				_this.popupBind(newItem);

				if (ko.dataFor($("#entry-details").get(0)) == undefined)
				{
					ko.applyBindings(_this.popupBind, $("#entry-details").get(0));
				}
				$("#entry-details").modal('show');
			};

			self.cancel	= function(isNew){
				return function(item, elem){
					item.rollback();
					item.project_task_id(0);
					item.activity_name("");

					$.each(item.hours_list_week(), function(key, val){
						val.hours(null);
					});

					_this.appModel.week_view().is_options(false);

					if (!isNew)
					{
						item.is_edit_mode(false);
					}
				};
			};

			self.prepareNew		= function(item){

				var retData	= "";
				if (item.project_id() <= 0 || item.task_type_id() <= 0)
				{
					alert("Project and Task type required.");
					return false;
				}

				retData	= {
					project_id		: item.project_id(),
					task_type_id	: item.task_type_id(),
					project_task_id	: item.project_task_id() || 0,
					activity_name	: item.activity_name(),
					task_number		: item._info.task_number(),
					is_billable		: item.is_billable()==true?1:0,
					is_new			: true,
					view			: "week",
					week_entries	: []
				};

				retData.project_task_id	= isNaN(retData.project_task_id) ? 0 : retData.project_task_id;

				$.each(item.hours_list_week(), function(key, val){
					if (val.hours() != "")
					{
						var entry	= {
							entry_date: new Date(val.entry_date()).format(Otime.sdf),
							hours: val.hours(),
							details: null
						};
						if (val.details() && val.details().length > 0)
						{
							entry.details	= JSON.parse(ko.toJSON(val.details));
						}
						retData.week_entries.push(entry);
					}
				});

				if (retData.week_entries.length <= 0)
				{
					alert("Please enter the hours");
					return false;
				}

				retData.user_id	= Otime.UID;
				if (!Otime.isM && _this.appModel)
				{
					retData.user_id	= (_this.appModel.sel_user()!=Otime.UID)?_this.appModel.sel_user():retData.user_id;
				}

				return retData;
			};

			self.prepareData	= function(item, isFromStart){
				if (item.hasChanges() == false)
				{
					self.cancel(item);
					return false;
				}

				if (parseFloat(item.hours()) > 0 || isFromStart)
				{
					var data	= JSON.parse(ko.toJSON(item));
					var task_id	= (self.project_task_id()+"").split("-")[0] || 0;
					task_id	= isNaN(task_id) ? 0 : task_id;

					data.project_id		= self.project_id();
					data.task_type_id	= self.task_type_id();
					data.activity_name	= self.activity_name();
					data.project_task_id= task_id;
					data.task_number	= self._info.task_number();
					data.view			= "week";
					data.hours			= data.hours || 0;
					delete data._info;

//					item.user_id	= Otime.UID;
					if (!Otime.isM && _this.appModel)
					{
						data.user_id	= (_this.appModel.sel_user()!=Otime.UID)?_this.appModel.sel_user():item.user_id;
					}

					return data;
				}

				return false;
			};

			// Blur Save
			self.save	= function(isNew, startClbk){
				return function(item, elem){
					data	= (isNew) ? self.prepareNew(item) : self.prepareData(item, typeof startClbk == "function");
					if (!data)
					{
						item.is_edit_mode && item.is_edit_mode(false);
						return false;
					}

					Otime.app.postData(new Otime.ContextModel({
						url: "save",
						global: false
					}, data, function(cont){
						var response	= cont.response;
						if (isNew)
						{
							data.hours_list_week	= {};

							$.each(JSON.parse(ko.toJSON(self.hours_list_week)), function(key, val){
								if (response[val.entry_date] != undefined)
								{
									val.time_sheet_id	= response[val.entry_date].time_sheet_id || 0;
									data.project_task_id	= data.project_task_id || response[val.entry_date].project_task_id || data.activity_name;
								}
								data.hours_list_week[val.entry_date]	= val;
							});

							delete data.week_entries;
							data.is_new	= false;
							var lst	= _this.appModel.week_view().listing(),
								isAdded	= false;

							for (var i=0; i<lst.length; i++)
							{
								if (lst[i].project_id() == Number(data.project_id) && lst[i].task_type_id() == Number(data.task_type_id) && lst[i].activity_name() == data.activity_name)
								{
									var weekLst	= lst[i].hours_list_week(),
										hrs	= 0;
									for (var j=0; j<weekLst.length; j++)
									{
										hrs	= Number(weekLst[j].hours()) + Number(data.hours_list_week[weekLst[j].entry_date()].hours);
										if (hrs > 0)
										{
											weekLst[j].hours(hrs.toFixed(2));
											weekLst[j].count(Number(weekLst[j].count()) + 1);
										}
									}
									isAdded	= true;
								}
							}

							if (!isAdded)
							{
								var pj	= Otime.TimeSheet.projects[data.project_id];
								data.bg_color	= (pj && pj.bg_color) ? pj.bg_color : "";

								data.hours_list_week	= Object.values(data.hours_list_week);
//								_this.appModel.week_view().listing.push(new _this.WeekListModel(data, false, daysList, parent));
								parent.listing.push(new _this.WeekListModel(data, false, daysList, parent));
							}
							self.cancel(true)(item, elem);
						}
						else
						{
							if (item.time_sheet_id() <= 0)
							{
								item.time_sheet_id(response[0].time_sheet_id);
							}

							/***
							 * Update Table headers day list hours.
							 */
							var itm	= null;
							for (var i=0,lst=daysList(),ln=lst.length; i<ln; i++)
							{
								itm	= lst[i];
								if (itm.date().format("YYYY-MM-DD") == item.entry_date())
								{
									itm.hours(Number((Number(itm.hours()) + (Number(item.hours() || 0) - Number(item.actual_hours || 0)))).toFixed(2));
									item.actual_hours	= item.hours();
									break;
								}
							}

							item.commit();
							item.is_edit_mode(false);

							typeof startClbk == "function" && startClbk(cont);
						}
					}));
					return true;
				};
			};

			self.start = function(item, elem, cont){
				// self.project_id();
				// self.task_type_id();
				// self.project_task_id();
				item	= item || self;
				var parentItem	= item;
				var lst	= item.hours_list_week();

				item	= null;

				var runningItem	= null;
				
				for (var i=0, len=lst.length; i<len; i++)
				{
					if (lst[i].is_progress())
					{
						item	= lst[i];
						break;
					}
					if (lst[i]._info.isToday())
					{
						item	= lst[i];
						break;
					}
				}

				if (!item)
				{
					var task_id	= parentItem.project_task_id().split("-")[0];
					task_id	= isNaN(task_id) ? 0 : task_id;

					Otime.app.postData(new Otime.ContextModel({
						url: "save",
						global: false,
						data: {
							project_id: parentItem.project_id(),
							project_task_id: task_id,
							task_type_id: parentItem.task_type_id(),
							activity_name: parentItem.activity_name(),
							is_billable: parentItem.is_billable(),
							entry_date: Otime.Date().format(Otime.sdf),
							hours: 0,
							actual_hours: 0
						},
						callback: function(cont){
							if (cont.response && cont.response[0] && cont.response[0].time_sheet_id)
							{
								Otime.app.loadData(new Otime.ContextModel({
									url: "start",
									global: false,
									data: {
										time_sheet_id: cont.response[0].time_sheet_id
									},
									callback: function(cont){
										var resp	= cont.response;
										_this.curTime	= resp.cur_time;
										Otime.Menu.curTime	= resp.cur_time;
									}
								}));
								return false;
							}
						}
					}));

					return true;
				}

				var updateHeaderTimer	= function(resp){
					var runItem	= Otime.Menu.progress();
					if (runItem && resp)
					{
						runItem.time_sheet_id(resp.time_sheet_id);
						runItem.hours(resp.hours);
						resp.entry_date && runItem.entry_date(Otime.stoj(resp.entry_date).format(Otime.jdf));
					}
				};

				var stopClbk	= function(_item, _parent, stopTime, resp){
					if (_item.entry_date() != new Date().format(Otime.jdf))
					{
						_this.ClearInterval();
						updateHeaderTimer(resp);
						_this.appModel.refresh_view();
						return true;
					}

					var startTime	= _item._info.from_time,
						endTime		= stopTime;

					var tot	= Number(_item.hours() + Number(jhelper.getTimeDiffPercent(startTime, endTime))).toFixed(2);
					_item.hours(Number(tot));

					_item._info.is_editable(true);
					_item._info.is_ts_running(false);
					_parent._info.is_ts_running(false);
					Otime.app.running_process(null);
					_this.appModel.active_item(null);
					_this.appModel.active_parent(null);
					_this.ClearInterval();
					updateHeaderTimer(resp);
				};

				if (parentItem._info.is_ts_running())
				{
					if (cont)
					{
						var resp	= cont.response;
						stopClbk(item, parentItem, resp.time);
						return;
					}
					else
					{
						/***
						 * Stop week view started timesheet
						 */
						Otime.app.loadData(new Otime.ContextModel({
							url: "stop",
							global: false,
							data: {
								time_sheet_id: item.time_sheet_id()
							},
							callback: function(cont){
								var resp	= cont.response;
								stopClbk(item, parentItem, resp.time, resp);
							}
						}));
					}
				}
				else
				{
					item._info.is_editable(false);
					var _startTS	= function(){
						/***
						 * Start week view timesheet for already existing item.
						 */
						Otime.app.loadData(new Otime.ContextModel({
							url: "start",
							global: false,
							data: {
								time_sheet_id: item.time_sheet_id()
							},
							callback: function(cont){
								var resp	= cont.response;

								_this.curTime	= resp.cur_time;
								Otime.Menu.curTime	= resp.cur_time;

								if (_this.appModel.active_item() && _this.appModel.active_parent())
								{
									stopClbk(_this.appModel.active_item(), _this.appModel.active_parent(), cont.response.time);
								}

								item._info.is_editable(false);
								item._info.is_ts_running(true);
								item._info.from_time	= cont.response.time.toString();
								parentItem._info.is_ts_running(true);

								Otime.Menu.activeTask	= {
									project_name: self._info.project_name(),
									time_sheet_id: cont.response.time_sheet_id,
									activity_name: self.activity_name(),
									is_progress: true,
									from_time: cont.response.time,
									hours:	item.hours()
								};
								Otime.Menu.initProgress();
								Otime.app.running_process(item);

								_this.appModel.active_item(item);
								_this.appModel.active_parent(parentItem);

								var tmpDay	= self.getTodayHeader(), tmpHrs=0;
								tmpDay.is_ts_running(true);

								_this.SetInterval(item._info.from_time, item, (item.hours()*60*60), _this.timerTmpl.week, null, function(item, op){
									tmpHrs	= +op.hours + (+op.minutes/60) - +item.hours();
									tmpDay.running_hours(+tmpDay.hours() + tmpHrs);
									self._info.running_hours(+self.total_hours() + tmpHrs);
									parent.running_hours(+parent.hours() + tmpHrs);
								});
							}
						}));
					};
					if (item.time_sheet_id() > 0)
					{
						_startTS();
					}
					else
					{
						/***
						 * Start week view timesheet for new item (Save then start).
						 */
						ko.editable(item);
						item.beginEdit();
						item._info.is_editable(true);
						self.save(false, function(cont){
							_startTS();
						})(item, elem);
						return true;
					}
				}
			};

			self.stop	= self.start;

			self.isApprove	= Otime.o(false);
			self.compute	= Otime.c(function(){
				if (self.hours_list_week() && self.hours_list_week().length > 0)
				{
					var tot	= 0,
						isApproveNeed = false;
					$.each(self.hours_list_week(), function(key, val){
						if (val.time_sheet_id())
						{
							isApproveNeed	=  (isApproveNeed || val.status()=="");
							tot	+= (val.hours() == "") ? 0 : parseFloat(val.hours());
						}
					});
					self.isApprove(isApproveNeed);
					self.total_hours(tot.toFixed(2));
				}
				if (_this.projects != null && self.project_id() > 0)
				{
					var obj	= _this.projects[self.project_id()];
					if (obj != undefined)
					{
						self._info.project_name(obj.project_code + obj.project_name);
						if (Number(self.task_type_id()) != 0 && obj.task_types[self.task_type_id()])
						{
							self._info.task_type_name(obj.task_types[self.task_type_id()].name);
						}
						else
						{
							self._info.task_type_name("");
//							self.activity_name("");	
						}
					}
					else
					{
						self._info.project_name("You are removed from this project.");
					}
				}
			});
		};

		/***
		 * Each cell in week view table will hold this object.
		 *  
		 * @param data
		 * @param isActive
		 * @returns
		 */
		_this.HoursListModel	= function(data, isActive, parent){
			var self	= this;

			data	= data || {};

			data.entry_date	= data.entry_date ? Otime.stoj(data.entry_date) : Otime.Date();
			data.actual_date	= data.actual_date ? Otime.stoj(data.actual_date) : Otime.Date();

			self.project_id		= Otime.o(data.project_id || 0);
			self.time_sheet_id	= Otime.o(data.time_sheet_id || 0);

			self.entry_date		= Otime.o(data.entry_date.format(Otime.jdf));
			self.count			= Otime.o(data.count || 0);
			self.max			= Otime.o(data.max || 0);
			self.notes			= Otime.o(data.notes || "");
			self.details		= Otime.a([]);
			self.status			= Otime.o(data.approval_status || "");
			self.invoice_id		= data.invoice_id-0 || 0;
			self.is_progress	= Otime.o(Boolean(Number(data.is_progress)));

			if (self.is_progress() && self.entry_date() != Otime.Date().format(Otime.jdf) && self.entry_date() == data.actual_date.format(Otime.jdf))
			{
				self.is_progress(false);
			}

			self._info	= {};
			self._info.is_editable	= Otime.o(true);
			self._info.user_role	= Otime.o(data.user_role || "");

			self._info.hours_disp		= Otime.o("");

//			self._info.date_disp		= Otime.o(data.entry_date);
			self._info.isToday			= Otime.o(data.entry_date.isToday());
			self._info.isFuture			= Otime.o(data.entry_date.isFuture());
			self._info.is_ts_running	= Otime.o(false);
			self._info.is_ts_running.subscribe(function(newVal){
				parent._info.is_ts_running(newVal);
			});
			self._info.approved_by		= Otime.o(data.approved_by-0 || 0);

			self._info.from_time		= data.from_time || "";

			data.hours	= data.hours ? parseFloat(data.hours).toFixed(2) : "";
			self.hours	= Otime.o(Number(data.hours) || "");
			self.hours.subscribe(function(newVal){
				self.hours(_this.CheckHours(newVal));
				parent.isApprove(parent.isApprove() || self.status()=="");
			});

			self.getParent	= function(){
				return parent;
			};

			self.is_edit_mode	= Otime.o(false);

			if (self.is_progress() && self._info.from_time)
			{
				self._info.is_editable(false);
				self._info.is_ts_running(true);
				Otime.app.running_process(self);
				_this.appModel.active_item(self);

				var tmpDay	= parent.getTodayHeader(),
					root	= parent.getParent(),
					tmpHrs	= 0;
				tmpDay.is_ts_running(true);

				_this.SetInterval(self._info.from_time, self, (self.hours()*60*60), _this.timerTmpl.week, null, function(item, op){
//					tmpHrs	= +op.hours + (+op.minutes/60) - +item.hours();
					tmpHrs	= +op.total_hours + (+op.minutes/60) - +item.hours();
					tmpDay.running_hours(+tmpDay.hours() + tmpHrs);
					parent._info.running_hours(+parent.total_hours() + tmpHrs);
					root.running_hours(+root.hours() + tmpHrs);
				});
			}

			self.compute	= Otime.c(function(){
				var dt	= new Date(self.entry_date());
				assignIsEditable(self);
//				self._info.is_editable((Boolean(Otime.AEODTS) && dt.getTime() <= Otime.Date().getTime()) || (dt.format(Otime.jdf) == Otime.Date().format(Otime.jdf)));
			});
		};

		_this.TimeSheetCalendarModel	= function(data){
			var self	= this;

			data	= data || {};

			self._info	= {};

			var last_item	= null;

			self.today	= new Date();
			self.current_date	= Otime.o(new Date(data.current_date || new Date()));
//			self.current_date	= Otime.o(new Date("2014/11/26"));
			self.is_allow		= Otime.o(false);

			self.selectedItem	= Otime.o(null);
			self.calendar	= null;

			self.itemsObj	= Otime.o({});

			self.isApprove	= Otime.o(false);

			self.title	= Otime.o("");

			self.saveOnResize	= function(data, tsId, tsDetailsId, from_time, to_time, isFuture){
//console.log("Save On Resize : ", data, tsId, tsDetailsId, from_time, to_time, isFuture);

				var newModel	= new _this.TimeSheetDetailModel(data);

//console.log("Details model length : ", newModel.details().length, tsDetailsId);
				if (!isFuture && newModel.details().length && tsDetailsId)
				{
					var tod	= Otime.Date();
					if (new Date(newModel.entry_date()).isToday())
					{
						if (tod < new Date(tod.format(Otime.jdf + " ") + from_time))
						{
							return false;
						}
						if (tod < new Date(tod.format(Otime.jdf + " ") + to_time))
						{
							to_time	= tod.format("HH:NN AP");
						}
					}

					$.each(newModel.details(), function(key, val){
						if (val.time_sheet_detail_id()-0 == tsDetailsId)
						{
							val.from_time(from_time || val.from_time());
							val.to_time(to_time || val.to_time());
							return false;
						}
					});
				}
				else if(!isFuture && from_time && to_time)
				{
					var tod	= Otime.Date();
					if (new Date(newModel.entry_date()).isToday())
					{
						if (tod < new Date(tod.format(Otime.jdf + " ") + from_time))
						{
							return false;
						}
						if (tod < new Date(tod.format(Otime.jdf + " ") + to_time))
						{
							to_time	= tod.format("HH:NN AP");
						}
					}

					newModel.details.push(new _this.HoursDetailModel({
						from_time: from_time,
						to_time: to_time
					}, newModel));
				}
				// if drop in future date delete all details & set timesheet id to zero
				if (isFuture)
				{
					if (newModel.hours()-0)
					{
						newModel.estimated_hours(newModel.hours());
						newModel.direct_entry(0);
						newModel.hours(0);
						newModel.total_hours(0);
						newModel.time_sheet_id(0);
					}
					newModel.details([]);
				}

				_saveItem(newModel);
				return true;
			};

			self.createNewModel	= function(data, isReturn){
				var newModel	= new _this.TimeSheetDetailModel(data);
				newModel.addHoursDetail();
				if (isReturn)
					return newModel;
				else
					self.selectedItem(newModel);
			};

			var _saveItem	= function(item, isTriggerStart){
				var isNew	= !item.time_sheet_id();

				_this.TimeSheetSave(item, function(response, cont, data){
					if (isNew)
					{
						data.details	= [];
						// if new item update the last_item to new item settings.
						last_item	= data;
					}

					if (isTriggerStart)
					{
						self.start(response.time_sheet_id);
						return;
					}
					self.refreshDate(item.entry_date());
//					self.selectedItem(null);
				});
			};

			self.start	= function(timesheet_id){
				Otime.app.loadData(new Otime.ContextModel({
					url: 'start',
					global: false
				}, {
					time_sheet_id: timesheet_id
				}, function(cont){
					if (cont.response)
					{
						self.refreshCalendar();
					}
				}));
			};

			self.stop	= function(timesheet_id, item){
				_this.ClearInterval();

				Otime.app.loadData(new Otime.ContextModel({
					url: 'stop',
					global: false
				}, {
					time_sheet_id: timesheet_id
				}, function(cont){
					if (cont.response)
					{
						var runItem	= Otime.Menu.progress();
						if (runItem && cont.response)
						{
							runItem.time_sheet_id(cont.response.time_sheet_id);
							runItem.hours(cont.response.hours);
							cont.response.entry_date && runItem.entry_date(Otime.stoj(cont.response.entry_date).format(Otime.jdf));
						}

						if (item && item.entry_date && item.entry_date.format(Otime.jdf) != Otime.Date().format(Otime.jdf))
						{
							self.refreshCalendar();
							return;
						}

						self.refreshCalendar(null, Otime.Date());
					}
				}));
			};

			self.saveStart	= function(item){
				if (item.time_sheet_id())
				{
					self.start(item.time_sheet_id());
				}
				else
				{
					_saveItem(item, true);
				}
			};

			self.save	= function(){
				_saveItem(self.selectedItem());
			};

			self.cancel	= function(){
				self.selectedItem(null);
			};

			self.moveToNextWeek	= function(item, elem){
				var newDate	= new Date(item.entry_date()).addDays(7).getWeekStart();
				item.entry_date(newDate.format(Otime.jdf));
				_saveItem(item);
			};

			self.prevNext	= function(addOrSub){
				return function(){
					self.current_date(new Date(self.current_date()).addDays((addOrSub + "7")-0));
					self.refreshCalendar();
				};
			};

			self.gotoToday	= function(){
				self.current_date(new Date(self.today));
				self.refreshCalendar();
			};

			self.submit	= function(item){
				var dt	= new Date(self.current_date());

				var data	= {
					week_view	: true,
					start_date: dt.getWeekStart().format(Otime.sdf),
					end_date: dt.getWeekEnd().format(Otime.sdf)
				};

				Otime.app.postData(new Otime.ContextModel({
					url: "submit",
					global: false
				}, data, function(cont){
					if (cont.response && cont.response[1])
					{
						Otime.success_message(cont.response[1], $("#alert_message"));
					}
					self.refreshCalendar();
				}));
			};

			self.loadInfo	= function(clbk){
				self.refreshCalendar(clbk);
			};

			self.refreshToday	= function(){
				self.refreshCalendar(null, Otime.Date());
			};

			self.refreshCalendar	= function(clbk, date){
				var dt	= new Date(self.current_date());
				var postData	= {};

				if (date)
				{
					date	= new Date(date);
					dt	= new Date(date);
					postData	= {
						start_date: dt.format(Otime.sdf),
						end_date: dt.format(Otime.sdf)
					};
				}
				else
				{
					postData	= {
						start_date: dt.getWeekStart().format(Otime.sdf),
						end_date: dt.getWeekEnd().format(Otime.sdf)
					};
				}

//				self.calendar.fullCalendar('removeEvents');
//				self.calendar.fullCalendar('gotoDate', new Date(dt));
//				var view	= self.calendar.fullCalendar('getView');
//				self.title(view.title);

				if (!Otime.isM)
				{
					postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
				}

				Otime.app.loadData(new Otime.ContextModel('listing/calendar', postData, function(cont){
					var resp	= cont.response;
					var itemsObj	= {};
					var calEvents	= [];

					if (date)
					{
						itemsObj	= self.itemsObj();
						for (var i=0, keys=Object.keys(itemsObj), iLen=keys.length; i<iLen; i++)
						{
							if (itemsObj[keys[i]] && itemsObj[keys[i]].data)
							{
								if (new Date(itemsObj[keys[i]].data.entry_date).toInt() == date.toInt())
								{
									delete itemsObj[keys[i]];
								}
								else
								{
									calEvents.push(itemsObj[keys[i]].calData);
								}
							}
						}
					}

//					self.calendar.fullCalendar('removeEvents');

					// for remove duplicate assigned tasks.
					var addedTasks	= [];

					if (resp.items && Object.keys(resp.items).length > 0)
					{
						var calData	= {};
						var _uid	= "";
						var isApproveNeed	= false;

						resp.items.otvalues.setKeys(resp.items.otkeys, function(val){
							(val.project_task_id-0) && addedTasks.push(val.project_task_id-0);

							if (val.time_sheet_id-0)
								isApproveNeed	=  (isApproveNeed || val.approval_status=="");
//						editable = assignIsEditable(val) && editable;

							if (val.details && Object.keys(val.details).length > 0)
							{
								val.entry_date	= Otime.stoj(val.entry_date);
								val.details.otvalues.setKeys(val.details.otkeys, function(v){
									_uid	= val.time_sheet_id + "#" + v.time_sheet_detail_id;
									calData	= {
										id: _uid,
										title: val.activity_name || val.project_name,
										entry_date: Otime.o(val.entry_date.format(Otime.jdf)),
										start: new Date(val.entry_date.format(Otime.jdf + " ") + v.from_time),
										end: new Date(val.entry_date.format(Otime.jdf + " ") + v.to_time),
										hours: Otime.o(v.hours-0),
										description: val.notes,
										allDay: false,
										bg_color: val.bg_color,
										estimated_hours: val.estimated_hours,
										is_progress: (val.is_progress-0 && v.is_progress-0),
										_info:{}
									};

									itemsObj[_uid]	= {
										data: val,
										calData: calData
									};

									if (val.is_progress-0 && v.is_progress-0)
									{
										// Old timer check.
										var todayDate	= Otime.Date().format(Otime.jdf);
										if (calData.entry_date() != todayDate)
										{
											calData.start	= new Date(todayDate + " " + v.from_time);
										}

										calData._info	= {
											hours_disp: Otime.o()
										}
										_this.curTime	= resp.cur_time;
										calData.stop	= function(item, elem, cont){
											if (calData.entry_date() != Otime.Date().format(Otime.jdf))
											{
												self.refreshCalendar();
											}
											else
											{
												self.refreshToday();
											}
//											self.stop(val.time_sheet_id-0);
										};

										Otime.app.running_process(calData);
//console.log(v, val, calData);
										_this.SetInterval(v.from_time, calData, val.hours*60*60, "HH:NN<sub>SS</sub>");
										Otime.Menu.activeTask	= {
											time_sheet_id: val.time_sheet_id,
											activity_name: val.activity_name,
											project_name: val.project_name,
											is_progress: true,
											from_time: v.from_time,
											hours:	val.hours
										};
										Otime.Menu.initProgress();
									}

									calEvents.push(calData);

									// _calender.fullCalendar('renderEvent', calData);
								});
							}
							else
							{
								_uid	= val.time_sheet_id;
								calData	= {
									id: _uid,
									title: val.activity_name || val.project_name,
									start: val.entry_date,
									end: val.entry_date,
									hours: val.hours-0,
									description: val.notes,
									allDay: true,
									bg_color: val.bg_color,
									estimated_hours: val.estimated_hours,
									is_progress: 0
								};

								calEvents.push(calData);

								itemsObj[_uid]	= {
									data: val,
									calData: calData
								};
							}
							last_item =  last_item || val;
						});
						self.isApprove(isApproveNeed);
					}

					if (resp.assigned_tasks && Object.keys(resp.assigned_tasks).length > 0)
					{
						var calData	= {};
						var _uid	= "";
						
						resp.assigned_tasks.otvalues.setKeys(resp.assigned_tasks.otkeys, function(val){
							if (addedTasks.indexOf(val.project_task_id-0)>=0)
							{
								return true;
							}

							_uid	= "Task-" + val.project_task_id;
							calData	= {
								id: _uid,
								title: val.activity_name || val.project_name,
								start: Otime.Date().format(Otime.sdf), //val.entry_date,
								end: Otime.Date().format(Otime.sdf), //val.entry_date,
								hours: 0,
								description: "",
								allDay: true,
								bg_color: val.bg_color,
								estimated_hours: 0,
								is_progress: 0
							};

							calEvents.push(calData);
							itemsObj[_uid]	= {
								data: val,
								calData: calData
							};
							last_item =  last_item || val;
						});
					}

					self.initCalendar({
						date: new Date(self.current_date()),
						events: calEvents
					});

					self.title(self.calendar.fullCalendar('getView').title);

//					self.calendar.fullCalendar('addEventSource', calEvents);

					self.itemsObj(itemsObj);

					self.cancel();

					typeof clbk == "function" && clbk();
				}));
			};

			self.refreshDate	= function(date){
				self.refreshCalendar(null, new Date(date));
			};

			var checkOverlap	= function(event){
//console.log("checkOverlap event : ", event);
				if (event._allDay)
				{
					event.allDay	= true;
					return false;
				}

				if (!event.end)
				{
					var hrs	= (event.hours-0) || (event.estimated_hours-0);
					event._end	= event.end	= event.start.clone().add(hrs, 'hours');
					return false;
				}

				var start	= event.start.clone().stripZone();
				var end		= event.end.clone().stripZone()
//console.log(start, end);
				var t	= self.calendar.data("fullCalendar");
				var overlap	= self.calendar.fullCalendar('clientEvents', function(ev){
					if (ev == event || ev.allDay)
						return false;
/*
					var eventStart	= ev.start.clone().stripZone();
					var eventEnd	= t.getEventEnd(ev).stripZone();

					return start < eventEnd && end > eventStart;
*/
					return start < t.getEventEnd(ev).stripZone() && end > ev.start.clone().stripZone();
				});

				if (overlap.length)
				{
					return true;
				}

				return false;
			}

			var checkFuture	= function(event, delta){
				if (event.start.clone().toDate().isFuture())
				{
					return true;
				}

				return false;
			};

			var eventIntersectsRange	= function(event, start, end){
				var eventStart	= event.start.clone().stripZone();
				var eventEnd	= t.getEventEnd(event).stripZone();

				return start < eventEnd && end > eventStart;
			}

			var hm2time	= function(hr, min){
				hr	= hr-0;
				min	= min-0;
				var ret	= "";
				if (hr > 12)
				{
					ret	= (hr-12).zp(2) + ":" + min.zp(2) + " PM";
				}
				else if (hr == 12)
				{
					ret	= "12:" + min.zp(2) + " PM";
				}
				else
				{
					ret	= hr.zp(2) + ":" + min.zp(2) + " AM";
				}

				return ret;
			};

			var isActive	= function(project_id){
				if (_this.projects[project_id])
				{
					return !!(_this.projects[project_id].is_active-0);
				}
				return true;
			};
//			headCellHtml
			self.initCalendar	= function(params){
				params	= params || {};

				self.calendar	= $('#timesheet-calendar');

				if (self.calendar.data("fullCalendar"))
				{
//					self.calendar.data("fullCalendar").destroy();
					self.calendar.removeData('fullCalendar');
//					self.calendar.data("fullCalendar", null);
				}
//				self.calendar.parent().append($("#timesheet-popup"));
				self.calendar.html("");
				self.calendar.attr("class", "");

//				self.calendar.fullCalendar("option", "height", self.calendar.parent().height());

				self.calendar.fullCalendar({
//					header: {
//						left: '',
//						center: '',
//						right: ''
//					},
					events: params.events || null,
					height: self.calendar.parent().height(),
//					height: "auto",
//					contentHeight:2500,
					header: false,
					now: Otime.Date(),
					defaultView: "agendaWeek",
//					defaultView: "basicWeek",
					firstDay: Otime.Days.daysList.indexOf(Otime.weekStart),
					defaultDate: params.date, //Otime.Date(),
					allDaySlot: true,
					allDayText: "",
					axisFormat: "h:mm",	// h:mm a
					slotDuration: "00:15:00",
					slotEventOverlap: false,	// multiple task in same time
					eventOverlap: true,
					eventStartEditable: true,
					scrollTime: Otime.Date().addHours(-1).format("HH:MM:SS", true), //"9:30:00",
//					minTime: "10:00:00",	// like Office start time
//					maxTime: "19:30:00",	// like Office end time
					timeFormat: "h:mm a",
					columnFormat: "ddd DD",
					selectable: true,
					editable: true,
					unselectAuto: true,	// unselect selected event when click anywhere else.
					dragScroll:true,	// auto scroll when draging.
//					eventConstraint: function(a, b){
//						console.log("eventConstraint : ", a, b);
//						return true;
//					},
//					dayClick: function(date, jsEvent, view){
//						console.log("dayClick : ", date, jsEvent, view);
//					},
					eventClick: function(event, jsEvent, view){
						// Set Editable here.
//						console.log("eventClick : ", event, jsEvent, view);

						var itemsObj	= self.itemsObj();

						if (itemsObj[event.id] && itemsObj[event.id].data)
						{
							var _dat	= itemsObj[event.id].data;
							var isProgress	= !!(_dat.is_progress-0);
							if ($(jsEvent.target).is(".fc-footer-start"))
							{
//								var itemsObj	= self.itemsObj();
//								itemsObj	= itemsObj[event.id].data;
								if (isProgress)
								{
//									self.stop(itemsObj.time_sheet_id-0);
									self.stop(_dat.time_sheet_id-0, _dat);
								}
								else
								{
									var newModel	= new _this.TimeSheetDetailModel(_dat);	// itemsObj
									newModel.status("");
									newModel._info.approved_by("");
									self.saveStart(newModel);
								}
								return false;
							}

							if (isProgress)
							{
								return false;
							}

							if (!isActive(_dat.project_id-0))
							{
								alert("Project for the timesheet is archived.");
								return false;
							}

							_dat	= self.createNewModel(JSON.parse(JSON.stringify(_dat)), true);
							if (!assignIsEditable(_dat))
							{
								alert("Timesheet not editable.");
								return false;
							}

							self.selectedItem(_dat);

							_this.save	= self.save;
							_this.cancel	= self.cancel;
						}
					},
//					eventDragStop: function(event, jsEvent, ui, view){
//						console.log("eventDragStop : ", event, jsEvent, ui, view);
//					},
					eventDrop: function(event, delta, revertFunc, jsEvent, ui, view){
//						console.log("eventDrop : ", event, delta, revertFunc, jsEvent, ui, view);

						if (checkOverlap(event))
						{
							revertFunc();
							return false;
						}

						var isFuture	= false;
						// if drop in future date then set it as just estimated hrs & set it in All-Day events.
						if (checkFuture(event, delta))
						{
							isFuture	= true;
							event.allDay	= true;
						}
						else
						{
							event.allDay	= event.allDay;
						}

						var itemsObj	= self.itemsObj();
						if (itemsObj[event.id] && itemsObj[event.id].data)
						{
							var data = itemsObj[event.id].data;
							if (!!(data.is_progress-0) || checkOverlap(event))
							{
								revertFunc();
								return false;
							}

							if (!isActive(data.project_id-0))
							{
								revertFunc();
								alert("Project for the timesheet is archived.");
								return false;
							}

							if (!(data.hours-0))
							{
								data.approval_status	= "";
							}

							if (data.approval_status)
							{
								revertFunc();
								return false;
							}

							var tsId	= event.id.split("#"),
								result	= true;
							var tsDetailId	= (tsId[1] || 0)-0;
							tsId	= (tsId[0] || 0)-0;

							if (!event.allDay)
							{
								var data	= JSON.parse(JSON.stringify(data));

								if (0 < (data.hours-0) && 0 != delta.days())
								{
									data.time_sheet_id	= 0;
									data.details	= [];
									result	= false;
								}

								if (delta.days())
								{
									data.entry_date	= Otime.Date(data.entry_date).addDays(delta.days()).format(Otime.sdf);
								}

								var start	= event.start.clone().stripZone();
								var from_time	= hm2time(start.hours(), start.minutes());

//								if (event.hours-0)
//								{
//									event.hours
//								}
								var end	= event.end.clone().stripZone();
								var to_time	= hm2time(end.hours(), end.minutes());

//console.log("Called : ", data, tsId, tsDetailId, from_time, to_time, isFuture);
								result	= self.saveOnResize(data, tsId, tsDetailId, from_time, to_time, isFuture) && result;
							}
							else
							{
								var data	= JSON.parse(JSON.stringify(itemsObj[event.id].data));
								data.entry_date	= Otime.Date(data.entry_date).addDays(delta.days()).format(Otime.sdf);
								result	= self.saveOnResize(data, tsId, tsDetailId, null, null, isFuture) && result;
							}

							if (!result)
								revertFunc();
							else
								delete itemsObj[event.id];
//console.log("eventResize ", tsDetailId, tsId, itemsObj[event.id], itemsObj[event.id].data);
						}
//console.log("Drop Allow : ");
					},
					eventResize: function(event, delta, revertFunc, jsEvent, ui, view){
//						console.log("eventResize : ", event, delta, revertFunc, jsEvent, ui, view);
						if (delta.days() || checkOverlap(event))
						{
							revertFunc();
							return false;
						}

						var itemsObj	= self.itemsObj();
						if (itemsObj[event.id] && itemsObj[event.id].data)
						{
							var data	= itemsObj[event.id].data;
							if (!!(data.is_progress-0))
							{
								revertFunc();
								return false;
							}

							if (!(data.project_id-0))
							{
								revertFunc();
								alert("Project for the timesheet is archived.");
								return false;
							}

							if (data.approval_status)
							{
								revertFunc();
								return false;
							}

							var tsId	= event.id.split("#");
							var tsDetailId	= (tsId[1] || 0)-0;
							tsId	= (tsId[0] || 0)-0;

							var end	= event.end.clone().stripZone();
							var to_time	= "";
							var to_time	= hm2time(end.hours(), end.minutes());

							self.saveOnResize(JSON.parse(JSON.stringify(data)), tsId, tsDetailId, null, to_time, false) || revertFunc();

//console.log("eventResize ", tsDetailId, tsId, itemsObj[event.id], itemsObj[event.id].data);
						}
					},
					eventRender: function(event, element, view){
						if ((event.estimated_hours-0) && !(event.hours-0))
						{
							element.addClass('est');
							//element.toggleClass('est');
						}

						element.css({
							'background-color': event.bg_color,
							'border': '1px solid ' + event.bg_color
						});

						var div	= $("<div/>");
						div.addClass("fc-footer-left hrs");
						div.html((event.hours-0)?parseFloat(event.hours).toFixed(2):"&nbsp;");
						div.appendTo(element);

						var div2	= $("<div/>");
						div2.addClass("fc-footer-right est-hrs");
						div2.html((event.estimated_hours-0) || "&nbsp;");
						div2.appendTo(element);

						if (!!event.is_progress)
						{
							element.addClass('timer');
							div.addClass("fc-footer-timer");
							event._info.hours_disp.subscribe(function(newVal){
								div.html(newVal);
							});

							var stop_btn	= $('<a href="javascript:;">&#9646;&#9646;&nbsp;</a>');
							stop_btn.addClass("fc-footer-start stop");
							stop_btn.appendTo(element);
//console.log("Timer : ", event, view);
						}
						else
						{
							var start_btn	= $('<a href="javascript:;">&#9654;&nbsp;</a>');
							start_btn.addClass("fc-footer-start start");
							start_btn.appendTo(element);
						}
//console.log("Event render : ", event.is_progress, element);
					},
//					viewRender: function(view, element){
//console.log("View Render : ", view, element);
//					},
//					dayRender: function(date, cell){
//console.log("Day Render : ", date, cell);
//						if (date > maxDate){
//						$(cell).addClass('disabled');
//					},
					headCellHtmlRender: function(row, col, date){
						var ret	= "";
						if (date.toDate().isLeave())
						{
							ret += "leave";
						}
						if (date.toDate().isToday())
						{
							ret += " today";
						}
						return ret;
					},
					select: function(start, end, jsEvent, view){
						// for programmatically selecting a period of time.
						// use like this
						// elem.fullCalendar('select', start, [ end ]);
//console.log("eventSelect : ", start, end, jsEvent, view);

						// In IE use UTC in date string,
						// Other browser use GMT in date string.
						var startDate	= new Date(start.toDate().toUTCString().replace(" GMT", "").replace(" UTC", ""));
						var endDate	= new Date(end.toDate().toUTCString().replace(" GMT", "").replace(" UTC", ""));

//						var isAllDay	= false;
						if (startDate.getDate() != endDate.getDate())
						{
//							isAllDay	= true;
							self.calendar.fullCalendar('unselect');
//							return false;
						}

						var currentTime	= new Date(),
							newModel	= null,
							hours	= (endDate - startDate)/36E5;

						// hours	= (24 <= hours) ? 1 : hours;

						// Estimated hours
						if (startDate > currentTime)
						{
							newModel	= new _this.TimeSheetDetailModel({
								entry_date: new Date(startDate),
								estimated_hours: hours
							});
						}
						else
						{
							newModel	= new _this.TimeSheetDetailModel({
								entry_date: new Date(startDate)
							});

							newModel.addHoursDetail();
							var detail	= newModel.details()[0];
							detail.from_time(startDate.format("HH:NN AP"));
							detail.to_time(endDate.format("HH:NN AP"));
						}

						newModel._info.is_extra(false);

						if (last_item)
						{
							newModel.project_id(last_item.project_id);
							newModel.task_type_id(last_item.task_type_id);
						}
						self.selectedItem(newModel);
						_this.save	= self.save;
						_this.cancel	= self.cancel;

//						self.calendar.fullCalendar('unselect');
					}
//					eventMouseover: function(event, jsEvent, view){
//						console.log("eventMouseover : ", event, jsEvent, view);
//					},
//					eventMouseout: function(event, jsEvent, view){
//						console.log("eventMouseout : ", event, jsEvent, view);
//					},
//					unselect: function(view, jsEvent){
//						// for programmatically clearing the current selection.
//						// elem.fullCalendar('unselect');
//
//						console.log("onUnselect : ", view, jsEvent);
//					},
//					events: [{id:'', title:'My Event', description:'Hai Welcome', start:'2014-11-28T10:30:00', end:'2014-11-28T11:45:00',  allDay: false}],
//					events: [{id:'', title:'My Event', editable:true, description:'Hai Welcome 2', start:'2014-11-28T10:30:00', end:'2014-11-28T11:45:00', duration:5, allDay: false}, {id:'', title:'My Event', editable:true, description:'Hai descrip', start:'2014-11-28T11:30:00', end:'2014-11-28T12:45:00', duration:5, allDay: false}],
				});
//				$("#timesheet-popup").draggable();
//				$(".fc-agendaWeek-view table tbody tr td.fc-widget-content div.fc-time-grid-container .fc-time-grid", self.calendar).append($("#timesheet-popup"));

				return self.calendar;
			};
		};

		_this.Tasks	= new function TaskSearch(){
			var _self	= this;

			_self.list	= {};

			_self.isNullResult	= false;

			_self.get	= function(request, callback, self){
				request.term	= $.trim(request.term);

				var pid	= self.project_id() || 0,
					tid	= self.task_type_id() || 0;
/*
				var _key	= "P"+pid+"TT"+tid+(request.term || "__null__");
//	console.log(_key, _self.list, _self.isNullResult && !_self.list[_key]);
				if ((_self.isNullResult && !_self.list[_key]) || pid <= 0 || tid <= 0)
				{
//					console.log("Called1", _self.isNullResult, _self.list[_key], pid, tid);
					callback([]);
					return [];
				}
*/
				if (request.term == "")
				{
					self.project_task_id(0);
					return false;
				}
/*
				if (_self.list[_key])
				{
					callback(_self.list[_key]);
					return [];
				}
*/
				$.ajax({
					type: "POST",
					url: Otime.siteUrl + "/timesheet/tasks",
					data: {
						term: request.term,
						task_type_id: tid,
						project_id: pid
					},
					success: function(response){
						if (is_expired(response))
						{
							return;
						}
						if(response[0] == true && response[2].length > 0)
						{
							var ret	= [];
							$.each(response[2], function(key, item){
								ret.push({
									label : item.name,
									value : item.name,
									id : item.task_id,
									task_number: item.task_number,
									billable : item.is_billable,
									task_type_id:item.task_type_id
								});
							});
//							_self.isNullResult	= false;
//							_self.list[_key]	= ret;
							callback(ret);
			            }
						else
						{
//							_self.isNullResult	= true;
						}
					},
					dataType: "JSON",
					global: false
				});
			};

			_self.set	= function(event, ui, self){
				if (Number(ui.item.id) != 0)
				{
					self.project_task_id(ui.item.id);
					self.activity_name.original_value	= ui.item.label;
					self.activity_name(ui.item.label);
					self._info.task_number(ui.item.task_number);
					self.is_billable(ui.item.billable == 1);
					self.task_type_id(ui.item.task_type_id-0 || self.task_type_id());
				}
			};

			return _self;
		};

		_this.Render	= function(item, callback){
			callback	= callback || "";

			var dy	= new Date(item.current_date());

			item.is_allow(new Date(dy.format(Otime.jdf)) <= new Date(item.today.format(Otime.jdf)));

			if(item.is_allow() == false && _this.appModel.is_day_view == false)
			{
				Otime.error_message(_this.language["ADVANCED_DATES_ARE_NOT_ALLOWED"], $("#timesheet-container #alert_message"));
			}
			else
			{
			    $("#timesheet-container #alert_message").html("");
			}

			if (item.days)
			{
				dy.addDays(Otime.Days.prevDaysCnt(dy));
				var tm	= new Date(dy);
				var url	= "get_hours/" + tm.format("YYYY-MM-DD") + "/";
				tm.addDays(6);
				url	+= tm.format(Otime.sdf);

				var postData	= {};
				if (!Otime.isM)
				{
					postData.user_id	= _this.appModel.sel_user() || Otime.UID || 0;
				}
				Otime.app.loadData(new Otime.ContextModel(url, postData, function(cont){
					if (cont.response)
					{
						var temp	= [], i, d;
						for(i=0; i<7; i++)
						{
							var d	= new Date(dy);
							d.addDays(i);
							cont.response[d.format(Otime.sdf)]	= cont.response[d.format(Otime.sdf)] || {day_total:0, entry_data:d.format(Otime.sdf)};
							temp.push(new _this.DayModel({
								date: d,
								hours: parseFloat(cont.response[d.format(Otime.sdf)].day_total).toFixed(2) || 0
							}));
						}
						item.days(temp);
						item.loadInfo(callback);
					}
				}));
			}
			else
			{
				item.loadInfo(callback);
			}

			return true;
		};

		_this.loadFilters	= function(userId, clbk){
			info_loaded = true;
			var url = (userId)?('info/' + userId):'info';
			Otime.app.loadData(new Otime.ContextModel(url, null, function(context){
				var data	= context.response;

				var task_types	= {};

				if (data.task_types && data.task_types.otvalues)
				{
					task_types	= data.task_types.otvalues.setKeys(data.task_types.otkeys, null, "task_type_id");
				}

				if (data.projects && data.projects.otvalues)
				{
					_this.projectSelectBox	= [];
					var projects	= data.projects.otvalues.setKeys(data.projects.otkeys, function(itm){
						if (!!(itm.is_active-0))
						{
							_this.projectSelectBox.push({
								label: itm.project_code + itm.project_name,
								value: itm.project_code + itm.project_name,
								id: itm.project_id
							});
						}
					}, "project_id");

					data.project_task_types	= data.project_task_types.otvalues.setKeys(data.project_task_types.otkeys, function(itm){
						if (!projects[itm.project_id]["task_types"])
							projects[itm.project_id]["task_types"]	= {};

						projects[itm.project_id]["task_types"][itm.task_type_id]	= $.extend(task_types[itm.task_type_id], itm);
					});
					_this.projects	= projects;
					_this.appModel.projects(_this.projectSelectBox);
				}
				else
				{
					_this.appModel.projects([]);
					Otime.show_propop('Track Your Time', 'Create your project to track your time');
				}

				_this.appModel.act_pro(data.act_pro || []);

				clbk && typeof clbk == "function" && clbk();
			}));
		};

		_this.UpdateContainers	= function(){
			_this.list_container	= $("#timesheet-container");
			_this.edit_container	= $("#edit-layout");
			_this.add_container		= $("#edit-layout");
		};

		_this.loadTemplates	= function(clbk){
			var url	= Otime.siteUrl + '/timesheet/tmpl';
			$.get(url, {
				v: Otime.version,
				r: Otime.usr,
				ar: (Otime.isAR ? 1 : 0),
				mb: (Otime.isModifyBillable ? 1 : 0),
				tsr: (Otime.tsReq ? 1 : 0)
			}, function(content){
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			});
		};

		_this.init	= function(){
			info_loaded	= false;
			_this.UpdateContainers();

			Otime.unbind();

			_this.popupBind	= Otime.o(null);

			Otime.shortcut.clear();

			_this.appModel	= new _this.TimeSheetViewModel();
			if (_this.members && _this.members.otvalues)
			{
				_this.members	= _this.members.otvalues.setKeys(_this.members.otkeys, function(val){
					val.user_image	= Otime.USIP + (val.user_image || "no_user.jpg");
					val.disp_name	= val.first_name + ' ' +val.last_name;
				});
				_this.appModel.users_list(_this.members);
			}
			ko.applyBindings(_this.appModel, _this.list_container.get(0));

			Otime.shortcut.fEsc	= function(){
				typeof _this.cancel == "function" && _this.cancel();
			};

			Otime.shortcut.ctrlS	= function(){
				typeof _this.save == "function" && _this.save();
			};

			$(document).unbind("keypress");
			$(document).keypress(Otime.KeyPress);

			if (!info_loaded)
				_this.appModel.load_view();
		};
	};
}(window.Otime));
